//   Standard File

////////////////////////////////////////////////////
// RenriVer8.70  DllLibrary Arduino  0.01         //
// c source builder by  SEQ_CBuilder V            //
// TargetCPU = ESP32(WROOM32)                     //
// make   webdns_M.h File  2019/02/11 19:41       //
////////////////////////////////////////////////////
#define	EEPROM_SIZE		1024

const byte DNS_PORT = 53; 
DNSServer dnsServer; 
char	recv_data[1024];	// 

int		nowpos = 0;			// 
int		analyzepos = 0;		// 

char		buf[256];		// 
WiFiServer	server(80);		// 

char	myssid[33];			// 
char	mypassword[33];		// 

unsigned	short portno = 0;
unsigned	long ipaddress = 0;

unsigned  short serial_set=0;
unsigned  char sysParam;
#define Y0018 	 (0x01 << 0) 
#define Y0019 	 (0x01 << 1) 
#define Y0025 	 (0x01 << 2) 
#define Y0026 	 (0x01 << 3) 
byte out_no[] = { 18 , 19 , 25 , 26}; 

#define GET_Y(DEVICE,NO) 	 (out_data & DEVICE)
#define SET_Y_ON(DEVICE,NO) 	 out_data = out_data | DEVICE
#define SET_Y_OFF(DEVICE,NO) 	 out_data = out_data & ~DEVICE

#define M0000 	 (0x01 << (0 % 16) ) 
#define M0001 	 (0x01 << (1 % 16) ) 
#define M0010 	 (0x01 << (10 % 16) ) 
#define M0011 	 (0x01 << (11 % 16) ) 

#define GET_M(DEVICE,NO) 	 (m_relay[ NO / 16 ] & DEVICE)
#define SET_M_ON(DEVICE,NO) 	 m_relay[ NO / 16 ] = m_relay[ NO / 16 ] | DEVICE
#define SET_M_OFF(DEVICE,NO) 	 m_relay[ NO / 16 ] = m_relay[ NO / 16 ] & ~DEVICE

unsigned short m_relay[1]; // 

// 使用する変数やマクロの宣言部

#define M9010   (0x01 << 0)   //  Errorフラグ
#define M9012   (0x01 << 1)   //  Carryフラグ
#define M9013   (0x01 << 2)   //  0(ゼロ)フラグ
#define M9030   (0x01 << 3)   // ０．１秒クロックパルス
#define M9031   (0x01 << 4)   // ０．２秒クロックパルス
#define M9032   (0x01 << 5)  // １．０秒クロックパルス
#define M9033   (0x01 << 6)  // ２．０秒クロックパルス
#define M9034   (0x01 << 7)  // ３０．０秒クロックパルス
#define M9038   (0x01 << 8)  // １－Ｓｃａｎ　On
#define M9036   (0x01 << 9)  // 常時　On　リレー
#define M9037   (0x01 << 10)  // 常時　ＯＦＦ　リレー
#define M9035   (0x01 << 11)  // 0.01秒　クロックパルス
#define M9003   (0x01 << 12) // 継続命令フラグ
#define M9039   (0x01 << 13)  // 0.005秒　クロックパルス
#define GET_E(DEVICE,NO)    (tokreg & DEVICE)
#define SET_E_ON(DEVICE,NO)  tokreg = tokreg | DEVICE
#define SET_E_OFF(DEVICE,NO)  tokreg = tokreg & ~DEVICE
unsigned long  tokreg; // 特殊リレー用変数

unsigned long starttime;
unsigned long lasttime;
unsigned long spantime;
unsigned long maxspantime;
unsigned long minspantime;
unsigned long lasttime_ms;
unsigned long spantime_ms;

unsigned long systemtime;
unsigned long systemtimes;
unsigned long systemtime10ms;
unsigned long in_data ;  // 入力Ｘの保持変数（３２点数分）
unsigned long out_data ;  // 出力Ｙの保持変数（３２点数分）

unsigned int  ldlg; // ブロック用変数
unsigned int  aax; // 回路の状態保持変数
unsigned int  iix;  // ＭＣの状態保持用変数
unsigned int  q;
unsigned int  trlg; // ＭＰＳ／ＭＲＤ／ＭＰＰ
byte        mcflg;  // ＭＣのフラグ
int			flag;


// standard function
void showMacAddress(){
	byte mac[6];                     // the MAC address of your Wifi shield
	WiFi.macAddress(mac);
	Serial.print("MAC: ");
	Serial.print(mac[5], HEX);
	Serial.print(":");
	Serial.print(mac[4], HEX);
	Serial.print(":");
	Serial.print(mac[3], HEX);
	Serial.print(":");
	Serial.print(mac[2], HEX);
	Serial.print(":");
	Serial.print(mac[1], HEX);
	Serial.print(":");
	Serial.println(mac[0], HEX);
}
void printEncryptionType(int thisType) {
// read the encryption type and print out the name:
	switch (thisType) {
	case 5: // ENC_TYPE_WEP
		Serial.println("WEP");
		break;
	case 2: // ENC_TYPE_TKIP
		Serial.println("WPA");
		break;
	case 4: // ENC_TYPE_CCMP
		Serial.println("WPA2");
		break;
	case 7: // ENC_TYPE_NONE
		Serial.println("None");
		break;
	case 8: // ENC_TYPE_AUTO
		Serial.println("Auto");
		break;
	default:
	Serial.print(thisType);
		Serial.println("");
	}
}
void listNetworks() {
// scan for nearby networks:
	Serial.println("** Scan Networks **");
	int numSsid = WiFi.scanNetworks();
	if (numSsid == -1) {
		Serial.println("Couldn't get a wifi connection");
		while (true);
	}
// print the list of networks seen:
	Serial.print("number of available networks : ");
	Serial.println(numSsid);
// print the network number and name for each network found:
	for (int thisNet = 0; thisNet < numSsid; thisNet++) {
		Serial.print(thisNet);
		Serial.print(") ");
		Serial.print(WiFi.SSID(thisNet));
		Serial.print("	Signal: ");
		Serial.print(WiFi.RSSI(thisNet));
		Serial.print(" dBm");
		Serial.print("	Encryption: ");
		printEncryptionType(WiFi.encryptionType(thisNet));
	}
}
void deviceSet(String devname, short value) {
	int i = 0;
	String buf;
	byte DevNo = 0;
	int iDevNo = 0;
	if (devname.charAt(1) == 'N') {
		buf = devname.substring(2);
	}else {
		buf = devname.substring(1);
	}
	char number[buf.length() + 1];
	buf.toCharArray(number, buf.length() + 1);
	switch (devname.charAt(0)) {
	case 'X':
		break;
	case 'Y':
		DevNo = atoi(number);
		for (i = 0; i<sizeof(out_no); i++) {
			if (DevNo == out_no[i]) {
				if (value == 1) {
					out_data = out_data | (1 << i);
				}else {
					out_data = out_data & ~(1 << i);
				}
			}
		}
		break;
	case 'M':
		iDevNo = atoi(number);
		if (value == 1) {
			m_relay[iDevNo / 16] = m_relay[iDevNo / 16] | (0x01 << (iDevNo ));
		} else {
			m_relay[iDevNo / 16] = m_relay[iDevNo / 16] & ~(0x01 << (iDevNo ));
		}
		break;
	case 'L':
		break;
	case 'D':
		break;
	case 'T':
		break;
	case 'C':
		break;
	case 'R':
		break;
	default:
		break;
	}
	//  Serial.print(iDevNo);
	//  Serial.print(":");
	//  Serial.print(DevNo);
	//  Serial.print(":");
	//  Serial.println(value);
}
void page0(WiFiClient client){
	 client.println("HTTP/1.1 200 OK");
	 client.println("Content-type:text/html");
	 client.println("Connection:close");  // the connection will be closed after completion of the response
	 client.println();
	 client.println("<!DOCTYPE HTML>\n<html><head lang=\"ja\"><meta charset=\"UTF-8\"></head>");
	 client.println("<body><main>");
	 client.println("<p>Ａｒｄｕｉｎｏデバイスモニタ・制御画面</p>");
	 client.println("<iframe src=\"page2\" style=\"width:auto; height:600px\"></iframe>");
	 client.println("<iframe src=\"page1\" style=\"width:auto; height:600px\"></iframe>");
	 client.println("</main></body>");
	 client.println("</html>");
}
void page1(WiFiClient client){
	 client.println("HTTP/1.1 200 OK");
	 client.println("Content-type:text/html");
	 client.println("Connection:keep-alive");  // the connection will be keeped after completion of the response
	 client.println("Refresh: 1");  // refresh the page automatically every 1 sec
	 client.println();
	 client.println("﻿<!DOCTYPE HTML> \n");
	 client.println("<html><head lang='ja'><meta charset='UTF-8'><title>デバイスモニタ</title></head> \n");
	 client.println("<body>\n");
	 client.println("<h2>デバイス監視盤</h2>\n");
	 client.println("Y0018 is ");
	 client.println(GET_Y(Y0018,0018) ? 1:0);
	 client.println("<br />");
	 client.println("Y0019 is ");
	 client.println(GET_Y(Y0019,0019) ? 1:0);
	 client.println("<br />");
	 client.println("Y0025 is ");
	 client.println(GET_Y(Y0025,0025) ? 1:0);
	 client.println("<br />");
	 client.println("Y0026 is ");
	 client.println(GET_Y(Y0026,0026) ? 1:0);
	 client.println("<br />");
	 client.println("M0000 is ");
	 client.println(GET_M(M0000,0000) ? 1:0);
	 client.println("<br />");
	 client.println("M0001 is ");
	 client.println(GET_M(M0001,0001) ? 1:0);
	 client.println("<br />");
	 client.println("M0010 is ");
	 client.println(GET_M(M0010,0010) ? 1:0);
	 client.println("<br />");
	 client.println("M0011 is ");
	 client.println(GET_M(M0011,0011) ? 1:0);
	 client.println("<br />");
	 client.println("<br / > \n");
	 client.println("scantime is \n");
	 client.println(spantime);
	 client.println("<br / > \n");
	 client.println("maxspantime is \n");
	 client.println(maxspantime);
	 client.println("<br / > \n");
	 client.println("minspantime is \n");
	 client.println(minspantime);
	 client.println("<br / > \n");
	 client.println("</body></html>\n");
}
void page2(WiFiClient client){
	 client.println("HTTP/1.1 200 OK");
	 client.println("Content-type:text/html");
	 client.println("Connection:close");  // the connection will be closed after completion of the response
	 client.println();
	 client.println("﻿<!DOCTYPE HTML> ");
	 client.println("<html><head lang='ja'><meta charset='UTF-8'></head> ");
	 client.println("<body> ");
	 client.println("<h2>デバイス制御盤</h2><br / > ");
	 client.println(" ");
	 client.println("<form method='get' action='page2'> ");
	 client.println("<form method='get' action='page2'> ");
	 client.println("Y0018 変更");
	 client.println("<input type = 'submit' name = 'Y0018' value = '0'> ");
	 client.println("<input type = 'submit' name = 'Y0018' value = '1'> ");
	 client.println("<br />");
	 client.println("Y0019 変更");
	 client.println("<input type = 'submit' name = 'Y0019' value = '0'> ");
	 client.println("<input type = 'submit' name = 'Y0019' value = '1'> ");
	 client.println("<br />");
	 client.println("Y0025 変更");
	 client.println("<input type = 'submit' name = 'Y0025' value = '0'> ");
	 client.println("<input type = 'submit' name = 'Y0025' value = '1'> ");
	 client.println("<br />");
	 client.println("Y0026 変更");
	 client.println("<input type = 'submit' name = 'Y0026' value = '0'> ");
	 client.println("<input type = 'submit' name = 'Y0026' value = '1'> ");
	 client.println("<br />");
	 client.println("</form> ");
	 client.println("<form method='get' action='page2'> ");
	 client.println("M0000 変更");
	 client.println("<input type = 'submit' name = 'M0000' value = '0'> ");
	 client.println("<input type = 'submit' name = 'M0000' value = '1'> ");
	 client.println("<br />");
	 client.println("M0001 変更");
	 client.println("<input type = 'submit' name = 'M0001' value = '0'> ");
	 client.println("<input type = 'submit' name = 'M0001' value = '1'> ");
	 client.println("<br />");
	 client.println("M0010 変更");
	 client.println("<input type = 'submit' name = 'M0010' value = '0'> ");
	 client.println("<input type = 'submit' name = 'M0010' value = '1'> ");
	 client.println("<br />");
	 client.println("M0011 変更");
	 client.println("<input type = 'submit' name = 'M0011' value = '0'> ");
	 client.println("<input type = 'submit' name = 'M0011' value = '1'> ");
	 client.println("<br />");
	 client.println("</form> ");
	 client.println("<form method='get' action='page2'> ");
	 client.println("</form> ");
	 client.println("</body> ");
	 client.println("</html> ");
}
void webpage(void *arg) {
	 // listen for incoming clients
	 while(1){
		delay(1);
	  dnsServer.processNextRequest();
	  delay(1);
		WiFiClient client = server.available();
		int waitcount=0;
		if (client) {
		String currentLine = "";
	  int	pageNumber = 1;
		while (client.connected()) {
	//		waitcount++;
	//		if (waitcount>3000) {waitcount=0; break;}
			if (client.available()) {
				char c = client.read();
//				Serial.write(c);
				if (c == '\n') {
					if (currentLine.length()==0){
						if (pageNumber == 1) {
							page1(client);
							maxspantime=0; minspantime=0xffffff;
						} else if (pageNumber == 2){
							page2(client);
						} else {
							page0(client);
						}
						break;
					} else {
						int getpos = currentLine.indexOf("GET");
						int pos = currentLine.indexOf("?");
						int endpos = currentLine.indexOf("HTTP/1.1");
						int andpos = 0;
						int equalpos = 0;
						String dev;
						String val;
						String pageStr;
						char  valarray[val.length()+1];
						short value;
						if (getpos>=0) { // GETHeader Check
							if (endpos >= 0) { // HTTP/1.1 Check 
								if (pos >= 4) {
									pageStr = currentLine.substring(4, pos);
								}
								else {
									pageStr = currentLine.substring(4, endpos - 1);
								}
								if (pageStr.equals("/")) {
									pageNumber = 0;
								}
								else if (pageStr.equals("/page1")) {
									pageNumber = 1;
								}
								else if (pageStr.equals("/page2")){
									pageNumber = 2;
								} else { pageNumber = 0; }
								if (pos>=0){ // Query Check
									pos += 1;
									andpos = currentLine.indexOf("&", pos);
									while (andpos<endpos) {
										equalpos = currentLine.indexOf("=", pos);
										if (equalpos<0) {
											break;
										}
										if (andpos>pos) {
											dev = currentLine.substring(pos, equalpos);
											val = currentLine.substring(equalpos + 1, andpos);
											val.toCharArray(valarray,val.length()+1);
											value = atoi(valarray);
											deviceSet(dev,value);
	//										Serial.println(dev + "," + val);
											pos = andpos + 1;
											andpos = currentLine.indexOf("&", andpos + 1);
										} else {
											dev = currentLine.substring(pos, equalpos);
											val = currentLine.substring(equalpos + 1, endpos);
											val.toCharArray(valarray,val.length()+1);
											value = atoi(valarray);
											deviceSet(dev,value);
	//										Serial.println(dev + "," + val);
											break;
										}
									}
								}
							} // HTTP/1.1 でない場合 
						} else {// GET HEADER でない場合
							
						}
					}
					currentLine = "";
	//				waitcount=0;
				} else if (c != '\r') {
					currentLine+=c;
				}

			}
			delayMicroseconds(0); //
		}
		client.stop();
	  delay(1);
	}
	}
}
void output_refresh() {
	 for (byte i=0; i<sizeof( out_no ); i++) { 
	 	 if ( out_data & (0x01 << i) ) {
	 	 	 digitalWrite( out_no[i], HIGH );
	 	 } else {
	 	 	 digitalWrite( out_no[i] , LOW );
	 	 }
	 }
}
// リンクリフレッシュ関数宣言部(将来のために用意)
void link_refresh()
{
	 
}
// タイマーの時間経過関数宣言部
void time_refresh() {
	 unsigned long nowtime; 
	 nowtime = micros(); 
	 spantime = nowtime - lasttime;
	 lasttime = nowtime;
	 nowtime = millis(); // 電源ＯＮ後の経過時間をmsで取得する
	 if (spantime>maxspantime) maxspantime=spantime;
	 if (spantime<minspantime) minspantime=spantime;
	 spantime_ms = nowtime - lasttime_ms;
	 lasttime_ms = nowtime;
	 
	 
} 
void writeEEPROM(int startAddr, int length, char* data) {
	 EEPROM.begin(EEPROM_SIZE);
	 for (int i = 0; i<length; i++) 
	 {
	 	 EEPROM.write(startAddr + i, data[i]);
	 }
	 EEPROM.commit();
	 EEPROM.end();
}
void readEEPROM(int startAddr, int length, char* data) {
	 EEPROM.begin(EEPROM_SIZE);
	 for (int i = 0; i<length; i++)
	 {
	 	 data[i] = EEPROM.read(startAddr + i);
	 }
	 EEPROM.end();
}
// special_relay refresh 
void special_refresh() {
// 500ms単位の動作（０．５秒のリレーを作る部分）
	 if ( systemtimes + spantime >= 500000) {
	 	 systemtimes = systemtimes + spantime - 500000;
	 	 if ( GET_E(M9032,0) ){
	 	 	 SET_E_OFF(M9032,0);
	 	 	 if (GET_E(M9033,0)) {
	 	 	 	 SET_E_OFF(M9033,0);
	 	 	 } else {
	 	 	 	 SET_E_ON(M9033,0);
	 	 	 } 
	 	 } else {
	 	 	 SET_E_ON(M9032,0);
	 	 } 
	 } else { 
	 	 systemtimes += spantime;
	 }

//' 50ms単位の動作（０．１秒のリレーを作る部分）
	 if ( systemtime + spantime >= 50000) { 
	 	 systemtime = systemtime + spantime - 50000;
	 	 if ( GET_E(M9030,0) ){
	 	 	 SET_E_OFF(M9030,0);
	 	 	 if (GET_E(M9031,0)) {
	 	 	 	 SET_E_OFF(M9031,0);
	 	 	 } else { 
	 	 	 	 SET_E_ON(M9031,0);
	 	 	 } 
	 	 } else {
	 	 	 SET_E_ON(M9030,0);
	 	 }
	 } else {
	 	 systemtime += spantime;
	 }
	 
// 5ms単位の動作（０．０１秒のリレーを作る部分）
	 if ( systemtime10ms + spantime >= 5000) {
	 	 systemtime10ms = systemtime10ms + spantime - 5000;
	 	 if ( GET_E(M9035,0) ){
	 	 	 SET_E_OFF(M9035,0);
	 	 	 if (GET_E(M9039,0)) {
	 	 	 	 SET_E_OFF(M9039,0);
	 	 	 } else {
	 	 	 	 SET_E_ON(M9039,0);
	 	 	 }
	 	 } else {
	 	 	 SET_E_ON(M9035,0);
	 	 }
	 } else {
	 	 systemtime10ms += spantime;
	 }
} 
/////////////// bcd to bin function (4digit)
int bcdbin( int a )
{ 
	 int q ;
	 q = a&0x0f ;
	 q +=((a&0xf0)>>4)*10 ;
	 q +=((a&0xf00)>>8)*100 ;
	 q +=((a&0xf000)>>12)*1000 ;
	 return( q ) ;
}
/////////////// bcd to bin function (8digit)
int bcd8bin( int a )
{ 
	 int q ;
	 q |=((a&0xf0)>>4)*10 ;
	 q |=((a&0xf00)>>8)*100 ;
	 q |=((a&0xf000)>>12)*1000 ;
	 q |=((a&0xf0000)>>16)*10000 ;
	 q |=((a&0xf00000)>>20)*100000 ;
	 q |=((a&0xf000000)>>24)*1000000 ;
	 q |=((a&0xf0000000)>>28)*10000000 ;
	 return( q ) ;
}

/////////////// bin to bcd function (4digit)
int binbcd(int a)
{ 
	 int q;
	 q = (a );
	 q += ( (a / 10) ) << 4; 
	 q += ( (a / 100) ) << 8; 
	 q += ( (a / 1000) ) << 12;
	 return (q);
} 

/////////////// bin to bcd function (8digit)
int bin8bcd(int a)
{
	 int q; 
	 q = (a ); 
	 q += ( (a / 10) ) << 4; 
	 q += ( (a / 100) ) << 8; 
	 q += ( (a / 1000) ) << 12; 
	 q += ( (a / 10000) ) << 16; 
	 q += ( (a / 100000) ) << 20; 
	 q += ( (a / 1000000) ) << 24; 
	 q += ( (a / 10000000) ) << 28; 
	 return (q); 
}

