//   Professional File

////////////////////////////////////////////////////
// RenriVer 8.74  DllLibrary Arduino  0.05         //
// c source builder by  SEQ_CBuilder V             //
// TargetCPU = ESP32(WROOM32) Library=M5Stack      //
// make RTCReadWrite.h File  2020/02/23 14:06  //
////////////////////////////////////////////////////
// printEfontを使用できるようにするためにヘッダファイルを宣言
// library efont Font Data for Arduino をダウンロードして、Ａｒｄｕｉｎｏに追加してください。
// #include "efontEnableAscii.h"; // 
// #include "efontEnableJa.h"; //  
// #include "efont.h"; // 
// #include "efontESP.h"; // 

#define 	 D9002 	 (nowPageNo)  
#define 	 D9005 	 (menupos)
#define 	 PageMaxCnt 	 5
short lastPageNo = -1; // 前回のページ番号を管理する変数
short nowPageNo = 0;     // 現在のページ番号を管理する変数
short menupos = 0;   // 選択するボタンの変数
short lastmenupos = 0; // 選択するボタンの変数の前回値

struct tm rtcTimeInfo;
#define D9030 (rtcTimeInfo.tm_year)
#define D9031 (rtcTimeInfo.tm_mon)
#define D9032 (rtcTimeInfo.tm_mday)
#define D9033 (rtcTimeInfo.tm_hour)
#define D9034 (rtcTimeInfo.tm_min)
#define D9035 (rtcTimeInfo.tm_sec)
#define RTC8564_ADDR	(0x51) 
#define RTC8564_MEMADDR  (0x2) 
unsigned  char sysParam;
#define X0037 	 (0x01 << 0) 
#define X0038 	 (0x01 << 1) 
#define X0039 	 (0x01 << 2) 
byte in_no[] = { 37 , 38 , 39}; 

#define   GET_X(DEVICE,NO) 	 (in_data & DEVICE)

#define   _INXUPPER_  (39) 

 #define D0000 	 (d_data[0] ) 
#define D0001 	 (d_data[1] ) 
#define D0002 	 (d_data[2] ) 
#define D0003 	 (d_data[3] ) 
#define D0004 	 (d_data[4] ) 
#define D0005 	 (d_data[5] ) 
#define GET_D(DEVICE,NO) 	 ( DEVICE )
#define SET_D(DEVICE,NO,DATA) 	 ( DEVICE ) = (DATA) 

#define D_VARIABLE(NO)   (d_data[NO])
#define D_UB_ARRAY(NO)   (((unsigned char*)&d_data[NO])+1)
#define D_LB_ARRAY(NO)   (((unsigned char*)&d_data[NO]))
#define D_ARRAY(NO)     (d_data[NO])
#define PTRD_ARRAY(NO)    (&d_data[NO])
short d_data[6]; // 

#define   _DATAUPPER_  (5) 

// 使用する変数やマクロの宣言部

#define M9010   (0x01 << 0)   //  Errorフラグ
#define M9012   (0x01 << 1)   //  Carryフラグ
#define M9013   (0x01 << 2)   //  0(ゼロ)フラグ
#define M9030   (0x01 << 3)   // ０．１秒クロックパルス
#define M9031   (0x01 << 4)   // ０．２秒クロックパルス
#define M9032   (0x01 << 5)  // １．０秒クロックパルス
#define M9033   (0x01 << 6)  // ２．０秒クロックパルス
#define M9034   (0x01 << 7)  // ３０．０秒クロックパルス
#define M9038   (0x01 << 8)  // １－Ｓｃａｎ　On
#define M9036   (0x01 << 9)  // 常時　On　リレー
#define M9037   (0x01 << 10)  // 常時　ＯＦＦ　リレー
#define M9035   (0x01 << 11)  // 0.01秒　クロックパルス
#define M9003   (0x01 << 12) // 継続命令フラグ
#define M9039   (0x01 << 13)  // 0.005秒　クロックパルス
#define M9040   (0x01 << 16)  // シリアル通信受信完了フラグ
#define M9041   (0x01 << 17)  // シリアル通信受信エラーフラグ
#define GET_E(DEVICE,NO)    (tokreg & DEVICE)
#define SET_E_ON(DEVICE,NO)  tokreg = tokreg | DEVICE
#define SET_E_OFF(DEVICE,NO)  tokreg = tokreg & ~DEVICE
unsigned long  tokreg; // 特殊リレー用変数

#define	UTRG0000	(0x01 << (0 % 16) )
#define	UTRG0001	(0x01 << (1 % 16) )
#define GET_UTRG(DEVICE,NO)  (u_plsg[NO/16] & DEVICE)  
#define SET_UTRG_ON(DEVICE,NO)   u_plsg[NO/16] = u_plsg[NO/16] | DEVICE
#define SET_UTRG_OFF(DEVICE,NO)  u_plsg[NO/16] = u_plsg[NO/16] & ~DEVICE
unsigned short u_plsg[1]; // 立ち上りパルス用のリレーフラグ
unsigned long starttime;
unsigned long lasttime;
unsigned long spantime;
unsigned long maxspantime;
unsigned long minspantime;
unsigned long lasttime_ms;
unsigned long spantime_ms;

unsigned long systemtime;
unsigned long systemtimes;
unsigned long systemtime10ms;
unsigned long in_data ;  // 入力Ｘの保持変数（３２点数分）
unsigned long out_data ;  // 出力Ｙの保持変数（３２点数分）

unsigned int  ldlg; // ブロック用変数
unsigned int  aax; // 回路の状態保持変数
unsigned int  iix;  // ＭＣの状態保持用変数
unsigned int  q;
unsigned int  trlg; // ＭＰＳ／ＭＲＤ／ＭＰＰ
byte        mcflg;  // ＭＣのフラグ
int			flag;


int bcdbin(int a);
int bcd8bin(int a);
int binbcd(int a);
int bin8bcd(int a);
void tftUpdate(void *args);
// TFTの初期化関数
void tftInit() { 
	 M5.Lcd.fillScreen(TFT_BLACK); // 
	 M5.Lcd.setTextDatum(MC_DATUM); 
	 D9002 = 1; 
   xTaskCreatePinnedToCore(tftUpdate,"tftupdate", 4096, NULL, 30, NULL, 1);
}
// TFTのページ変更関数
void tftPageChange(int no) { 
	 if ( (no <= PageMaxCnt) && (no >= 0) ) {
	 	 D9002 = no; 
	 }
}
// TFTのページ番号取得関数
int tftgetPageNo() { 
	  return D9002; 
}

// loop関数の中でTFTの表示更新関数  
void tftUpdate(void *args){
	 delay(10);
	 while(1){
	 	 delay(1);
	 	 M5.Lcd.setTextDatum(MC_DATUM); 
	// 前回のページ番号と今回のページ番号が違う場合は、画面をクリアして描画しなおす
	 if( (lastPageNo!=D9002) && (D9002 <= PageMaxCnt)){
	 	 M5.Lcd.setTextSize(3); //
	 	 switch (D9002) { 
	 	 case 0:
	 	 	 M5.Lcd.clear(TFT_BLACK); //
	 	 	 M5.Lcd.drawString("D9002=0",70,200);
	 	 	 break;
	 	 case 1:
	 	 	 M5.Lcd.clear(TFT_BLACK); //
	 	 	 M5.Lcd.drawString("D9002=1",70,200);
	 	 	 break;
	 	 case 2:
	 	 	 M5.Lcd.clear(TFT_BLACK); //
	 	 	 M5.Lcd.drawString("D9002=2",70,200);
	 	 	 
	 	 	 break;
	 	 case 3:
	 	 	 M5.Lcd.clear(TFT_BLACK); //
	 	 	 M5.Lcd.drawString("D9002=3",70,200);
	 	 	 
	 	 	 break;
	 	 case 4:
	 	 	 M5.Lcd.clear(TFT_BLACK); //
	 	 	 M5.Lcd.drawString("D9002=4",70,200);
	 	 	 
	 	 	 break;
	 	 case 5:
	 	 	 M5.Lcd.clear(TFT_BLACK); //
	 	 	 M5.Lcd.drawString("D9002=5",70,200);
	 	 	 
	 	 	 break;
	 	 }
	 	 M5.Lcd.setTextSize(2); //
	 	 M5.Lcd.setTextColor(TFT_BLACK,TFT_GREEN);
	 	 M5.Lcd.fillRect(12,12,46,46,TFT_GREEN);
	 	 M5.Lcd.drawString("P0",35,35);
	 	 M5.Lcd.fillRect(62,12,46,46,TFT_GREEN);
	 	 M5.Lcd.drawString("P1",85,35);
	 	 M5.Lcd.fillRect(112,12,46,46,TFT_GREEN);
	 	 M5.Lcd.drawString("P2",135,35);
	 	 M5.Lcd.fillRect(162,12,46,46,TFT_GREEN);
	 	 M5.Lcd.drawString("P3",185,35);
	 	 M5.Lcd.fillRect(212,12,46,46,TFT_GREEN);
	 	 M5.Lcd.setCursor(235,35); //
	 	 M5.Lcd.drawString("P4",235,35);
	 	 M5.Lcd.fillRect(262,12,46,46,TFT_GREEN);
	 	 M5.Lcd.drawString("P5",285,35);
	 	 
	 	 delay(1);
	 	 lastPageNo = D9002;
	 	 lastmenupos = -1;
	 } else {
	 	      char msg[30];
	 	 if (lastmenupos != D9005){
	 	 	 M5.Lcd.setTextSize(3); //
	 	 	 M5.Lcd.setTextColor(TFT_WHITE,TFT_BLACK);
	 	 	 sprintf(msg,"D9005=%d",D9005);
	 	 	 M5.Lcd.drawString(msg,70,225);
	 	 delay(1);
	 	 	 if(lastmenupos >= 0){
	 	 	 	 switch (lastmenupos){
	 	 	 	 	 case 0:
	 	 	 	 	 	 M5.Lcd.drawRect(10,10,50,50,TFT_BLACK);
	 	 	 	 	 	 break;
	 	 	 	 	 case 1:
	 	 	 	 	 	 M5.Lcd.drawRect(60,10,50,50,TFT_BLACK);
	 	 	 	 	 	 break;
	 	 	 	 	 case 2:
	 	 	 	 	 	 M5.Lcd.drawRect(110,10,50,50,TFT_BLACK);
	 	 	 	 	 	 break;
	 	 	 	 	 case 3:
	 	 	 	 	 	 M5.Lcd.drawRect(160,10,50,50,TFT_BLACK);
	 	 	 	 	 	 break;
	 	 	 	 	 case 4:
	 	 	 	 	 	 M5.Lcd.drawRect(210,10,50,50,TFT_BLACK);
	 	 	 	 	 	 break;
	 	 	 	 	 case 5:
	 	 	 	 	 	 M5.Lcd.drawRect(260,10,50,50,TFT_BLACK);  
	 	 	 	 	 	 break;
	 	 	 	 } 
	 	 	 delay(1);
	 	 	 } 
	 	 	 switch (D9005) {
	 	 	 	 case 0:
	 	 	 	 	 M5.Lcd.drawRect(10,10,50,50,TFT_YELLOW);;
	 	 	 	 	 break;
	 	 	 	 case 1:
	 	 	 	 	 M5.Lcd.drawRect(60,10,50,50,TFT_YELLOW);;
	 	 	 	 	 break;
	 	 	 	 case 2:
	 	 	 	 	 M5.Lcd.drawRect(110,10,50,50,TFT_YELLOW);;
	 	 	 	 	 break;
	 	 	 	 case 3:
	 	 	 	 	 M5.Lcd.drawRect(160,10,50,50,TFT_YELLOW);;
	 	 	 	 	 break;
	 	 	 	 case 4:
	 	 	 	 	 M5.Lcd.drawRect(210,10,50,50,TFT_YELLOW);;
	 	 	 	 	 break;
	 	 	 	 case 5:
	 	 	 	 	 M5.Lcd.drawRect(260,10,50,50,TFT_YELLOW);;
	 	 	 	 	 break;
	 	 	 }
	 	 	 delay(1);
	 	 	 lastmenupos = D9005;
	 	 }
	 	 if(D9002==1){
	 	 	 unsigned short bitmask;
	 	 	 unsigned short xpos=15,ypos=0;
	 	 	 int no;
	 	 	 #ifdef _INXUPPER_
	 	 	 bitmask = 0x01;
	 	 	 M5.Lcd.setTextSize(2); 
	 	 	 for(no=0; no < sizeof(in_no); no++){
	 	 	 	 if(no*30+xpos >=210){continue;}
	 	 	 	 sprintf(msg,"%02d",in_no[no] );
	 	 	 	 M5.Lcd.drawString(msg,no*30+xpos,80);
	 	 	 	 if(in_data & bitmask){
	 	 	 	 	 M5.Lcd.fillCircle(no*30+xpos ,100,10,TFT_RED);
	 	 	 	 } else {
	 	 	 	 	 M5.Lcd.fillCircle(no*30+xpos ,100,10,TFT_GREEN);
	 	 	 	 }
	 	 	 	 bitmask <<= 1;
	 	 	 	 delay(1);
	 	 	 }
	 	 	 #endif 
	 	 	 
	 	 	 #ifdef _OUTYUPPER_
	 	 	 bitmask = 0x01;
	 	 	 M5.Lcd.setTextSize(2); //
	 	 	 for(no=0; no < sizeof(out_no); no++){
	 	 	 	 if(no*30+xpos >=210){continue;}
	 	 	 	 sprintf(msg,"%02d",out_no[no] );
	 	 	 	 M5.Lcd.drawString(msg,no*30+xpos,122);
	 	 	 	 if(out_data & bitmask){
	 	 	 	 	 M5.Lcd.fillCircle(no*30+xpos ,142,10,TFT_RED);    
	 	 	 	 } else {
	 	 	 	 	 M5.Lcd.fillCircle(no*30+xpos ,142,10,TFT_GREEN);
	 	 	 	 }
	 	 	 	 bitmask <<= 1;
	 	 	 	 delay(1);
	 	 	 }
	 	 	 #endif
	 	 	 
	 	 	 #ifdef _MUPPER_
	 	 	 xpos = 5;
	 	 	 bitmask = 0x01;
	 	 	 for(no=0; no<16; no++){
	 	 	 	 if((no==0) || (no==4)|| (no==8) || (no==12)|| (no==15)){
	 	 	 	 	 sprintf(msg,"%02d",no );
	 	 	 	 	 M5.Lcd.setTextSize(1); //
	 	 	 	 	 M5.Lcd.drawString(msg,xpos+5,165);
	 	 	 	 }
	 	 	 	 
	 	 	 	 if(m_relay[0] & bitmask){
	 	 	 	 	 M5.Lcd.fillRect(xpos ,170 , 10 , 10 ,TFT_RED);   
	 	 	 	 } else {
	 	 	 	 	 M5.Lcd.fillRect(xpos ,170 , 10 , 10,TFT_GREEN);
	 	 	 	 }
	 	 	 	 bitmask <<= 1; 
	 	 	 	 xpos += 11;
	 	 	 	 delay(1);
	 	 	 }
	 	 	 #endif
	 	 	 xpos = 260;
	 	 	 ypos = 80;
	 	 	 M5.Lcd.setTextSize(2);
	 	 	 #ifdef _DATAUPPER_ 
	 	 	 	 #ifdef D0000
	 	 	 	 	 sprintf(msg,"D0=%04hX",D0000);
	 	 	 	 	 M5.Lcd.drawString(msg,xpos,ypos);
	 	 	 	 	 ypos += 18;
	 	 	 	 delay(1);
	 	 	 	 #endif
	 	 	 	 #ifdef D0001
	 	 	 	 	 sprintf(msg,"D1=%04hX",D0001);
	 	 	 	 	 M5.Lcd.drawString(msg,xpos,ypos);
	 	 	 	 	 ypos += 18;
	 	 	 	 delay(1);
	 	 	 	 #endif
	 	 	 	 #ifdef D0002
	 	 	 	 	 sprintf(msg,"D2=%04hX",D0002);
	 	 	 	 	 M5.Lcd.drawString(msg,xpos,ypos);
	 	 	 	 	 ypos += 18;
	 	 	 	 delay(1);
	 	 	 	 #endif 
	 	 	 #endif
	 	 	 #ifdef _TIMERUPPER_
	 	 	 	 #ifdef TN0000
	 	 	 	 	 sprintf(msg,"T0=%04d",TN0000);
	 	 	 	 	 M5.Lcd.drawString(msg,xpos,ypos);
	 	 	 	 	 ypos += 18;
	 	 	 	 delay(1);
	 	 	 	 #endif
	 	 	 	 #ifdef TN0001
	 	 	 	 	 sprintf(msg,"T1=%04d",TN0001);
	 	 	 	 	 M5.Lcd.drawString(msg,xpos,ypos);
	 	 	 	 	 ypos += 18;
	 	 	 	 delay(1);
	 	 	 	 #endif
	 	 	 	 #ifdef TN0002
	 	 	 	 	 sprintf(msg,"T2=%04d",TN0002);
	 	 	 	 	 M5.Lcd.drawString(msg,xpos,ypos);
	 	 	 	 	 ypos += 18;
	 	 	 	 delay(1);
	 	 	 	 #endif
	 	 	 #endif
	 	 	 #ifdef  _COUNTERUPPER_
	 	 	 	 #ifdef CN0000
	 	 	 	 	 sprintf(msg,"C0=%04d",CN0000);
	 	 	 	 	 M5.Lcd.drawString(msg,xpos,ypos);
	 	 	 	 	 ypos += 18;
	 	 	 	 delay(1);
	 	 	 	 #endif
	 	 	 	 #ifdef CN0001
	 	 	 	 	 sprintf(msg,"C1=%04d",CN0001);
	 	 	 	 	 M5.Lcd.drawString(msg,xpos,ypos);
	 	 	 	 	 ypos += 18;
	 	 	 	 delay(1);
	 	 	 	 #endif
	 	 	 	 #ifdef CN0002
	 	 	 	 	 sprintf(msg,"C2=%04d",CN0002);
	 	 	 	 	 M5.Lcd.drawString(msg,xpos,ypos);
	 	 	 	 	 ypos += 18;
	 	 	 	 delay(1);
	 	 	 	 #endif
	 	 	 #endif
	 	 	 
	 	 }
	 }
	 }
}
//RTC8564更新関数
void RTC8564Update(){
	 Wire.begin();  //  I2C開始
	 Wire.beginTransmission(RTC8564_ADDR);  // アドレス 0x51との通信を開始
	 Wire.write(RTC8564_MEMADDR);             // 書込みアドレスのセット（２番地）
	 Wire.write(D9035 & 0x7f);    // ＲＴＣの秒（0-59）(BCD)
	 Wire.write(D9034 & 0x7f);    // ＲＴＣの分（0-59）(BCD)
	 Wire.write(D9033 & 0x3f);    // ＲＴＣの時間（0-23）(BCD)
	 Wire.write(D9032 & 0x3f);    // ＲＴＣの日（1-31）(BCD)
	 Wire.write(0);    // ＲＴＣの週（0-7）(BCD)
	 Wire.write(D9031 & 0x1f);    // ＲＴＣの月（0-23）、世紀(BCD)
	 Wire.write(D9030 & 0xff);    // ＲＴＣの年（00-99）(BCD)
	 Wire.endTransmission();  // I2C終了
}
	 
//RTC8564取込関数
void RTC8564Input(){
	 Wire.begin();  //  I2C開始
	 Wire.beginTransmission(RTC8564_ADDR);  // アドレス 0x51との通信を開始
	 Wire.write(RTC8564_MEMADDR);             // 読出しアドレスのセット（２番地）
	 Wire.requestFrom(RTC8564_ADDR,32);   // アドレス 0x51との通信（受信）開始
	 D9035 = Wire.read() & 0x7f;     // ＲＴＣの秒（0-59）(BCD)
	 D9034 =Wire.read() & 0x7f;    // ＲＴＣの分（0-59）(BCD)
	 D9033 = Wire.read() & 0x3f;    // ＲＴＣの時間（0-23）(BCD)
	 D9032 =Wire.read() & 0x3f;    // ＲＴＣの日（1-31）(BCD)
	 Wire.read();   // ＲＴＣの週（0-7）(BCD)
	 D9031 = Wire.read() & 0x1f;    // ＲＴＣの月（0-23）、世紀(BCD)
	 D9030 = 0x2000 | Wire.read() & 0xff;    // ＲＴＣの年（00-99）(BCD)+0x2000
	 Wire.endTransmission();  // I2C終了
} 
	 
// // GYCOMT b0 D0 B1 P0 F0 L0 BIN0 11 0 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 X0039 0 1 
 // // MPS b0 D0 B0 P0 F0 L0 BIN0 1 1 
 // // // // MOV b0 D0 B0 P0 F0 L1 BIN1 H0020 D9030 11 1 
 // // // // MOV b0 D0 B0 P0 F0 L1 BIN1 H0002 D9031 11 2 
 // // // // MOV b0 D0 B0 P0 F0 L1 BIN1 H0023 D9032 11 3 
 // // // // MOV b0 D0 B0 P0 F0 L1 BIN1 H0023 D9033 11 4 
 // // // // MOV b0 D0 B0 P0 F0 L1 BIN1 H0059 D9034 11 5 
 // // // // MOV b0 D0 B0 P0 F0 L1 BIN1 H0050 D9035 11 6 
 // // MPP b0 D0 B0 P0 F0 L0 BIN0 1 1 
 // // // OUTR b0 D0 B0 P0 F0 L0 BIN0 M9022 11 7 
 // // GYCOMT b0 D0 B1 P0 F0 L0 BIN0 11 8 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 X0038 0 9 
 // // // OUTR b0 D0 B0 P0 F0 L0 BIN0 M9021 11 9 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 M9036 0 10 
 // // MPS b0 D0 B0 P0 F0 L0 BIN0 1 10 
 // // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D9030 D0005 11 10 
 // // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D9031 D0004 11 11 
 // // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D9032 D0003 11 12 
 // // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D9033 D0002 11 13 
 // // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D9034 D0001 11 14 
 // // MPP b0 D0 B0 P0 F0 L0 BIN0 1 10 
 // // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D9035 D0000 11 15 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 X0037 0 16 
 // // // AND b0 D0 B0 P0 F1 CSHOU L0 BIN0 X00C5 1 16 
 // // // INCB b0 D0 B0 P1 F0 L0 BIN0 D9005 11 16 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 X0039 0 17 
 // // // AND b0 D0 B0 P0 F1 CDAI L0 BIN0 X00C3 1 17 
 // // // DECB b0 D0 B0 P1 F0 L0 BIN0 D9005 11 17 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 M8000 0 18 
 // // MPS b0 D0 B0 P0 F0 L0 BIN0 1 18 
 // // // OUTR b0 D0 B0 P0 F0 L0 BIN0 M8005 11 18 
 // // MPP b0 D0 B0 P0 F0 L0 BIN0 1 18 
 // // // OUTR b0 D0 B0 P0 F0 L0 BIN0 M8004 11 19 
 // // END b0 D0 B1 P0 F0 L0 BIN0 11 20 
 // standard function
	
void input_refresh() {
	 	 for (byte i=0; i<sizeof(in_no); i++) { 
	 	 	 if (digitalRead(in_no[i])==HIGH) { 
	 	 	 	 in_data = in_data & ~(0x01 << i);
	 	 	 } else { 
	 	 	 	 in_data = in_data | (0x01 << i);
	 	 	 }
	 	 }
} 
	 
// リンクリフレッシュ関数宣言部(将来のために用意)
void link_refresh()
{
	 
}
// タイマーの時間経過関数宣言部
void time_refresh() {
	 unsigned long nowtime; 
	 nowtime = micros(); 
	 spantime = nowtime - lasttime;
	 lasttime = nowtime;
	 nowtime = millis(); // 電源ＯＮ後の経過時間をmsで取得する
	 if (spantime>maxspantime) maxspantime=spantime;
	 if (spantime<minspantime) minspantime=spantime;
	 spantime_ms = nowtime - lasttime_ms;
	 lasttime_ms = nowtime;
	 
	 
} 
// special_relay refresh 
void special_refresh() {
	 static unsigned long c30s = 0;
// 500ms単位の動作（０．５秒のリレーを作る部分）
	 if ( systemtimes + spantime >= 500000) {
	 	 systemtimes = systemtimes + spantime - 500000;
	 	 if ( GET_E(M9032,0) ){
	 	 	 SET_E_OFF(M9032,0);
	 	 	 if (GET_E(M9033,0)) {
	 	 	 	 SET_E_OFF(M9033,0);
	 	 	 } else {
	 	 	 	 SET_E_ON(M9033,0);
	 	 	 } 
	 	 } else {
	 	 	 SET_E_ON(M9032,0);
	 	 } 
	 	 c30s++; 
	 	 if (c30s>=30){ 
	 	 	 c30s=0; 
	 	 	 if(GET_E(M9034,0)){ 
	 	 	 	 SET_E_OFF(M9034,0); 
	 	 	 } else { 
	 	 	 	 SET_E_ON(M9034,0); 
	 	 	 } 
	 	 } 
	 	  
	 } else { 
	 	 systemtimes += spantime;
	 }

//' 50ms単位の動作（０．１秒のリレーを作る部分）
	 if ( systemtime + spantime >= 50000) { 
	 	 systemtime = systemtime + spantime - 50000;
	 	 if ( GET_E(M9030,0) ){
	 	 	 SET_E_OFF(M9030,0);
	 	 	 if (GET_E(M9031,0)) {
	 	 	 	 SET_E_OFF(M9031,0);
	 	 	 } else { 
	 	 	 	 SET_E_ON(M9031,0);
	 	 	 } 
	 	 } else {
	 	 	 SET_E_ON(M9030,0);
	 	 }
	 } else {
	 	 systemtime += spantime;
	 }
	 
// 5ms単位の動作（０．０１秒のリレーを作る部分）
	 if ( systemtime10ms + spantime >= 5000) {
	 	 systemtime10ms = systemtime10ms + spantime - 5000;
	 	 if ( GET_E(M9035,0) ){
	 	 	 SET_E_OFF(M9035,0);
	 	 	 if (GET_E(M9039,0)) {
	 	 	 	 SET_E_OFF(M9039,0);
	 	 	 } else {
	 	 	 	 SET_E_ON(M9039,0);
	 	 	 }
	 	 } else {
	 	 	 SET_E_ON(M9035,0);
	 	 }
	 } else {
	 	 systemtime10ms += spantime;
	 }
} 
/////////////// bcd to bin function (4digit)
int bcdbin( int a )
{ 
	 int q ;
	 q = a&0x0f ;
	 q +=((a&0xf0)>>4)*10 ;
	 q +=((a&0xf00)>>8)*100 ;
	 q +=((a&0xf000)>>12)*1000 ;
	 return( q ) ;
}
/////////////// bcd to bin function (8digit)
long bcd8bin( long a )
{ 
	 int q ;
	 q = ( a & 0xf );
	 q +=((a&0xf0)>>4)*10 ;
	 q +=((a&0xf00)>>8)*100 ;
	 q +=((a&0xf000)>>12)*1000 ;
	 q +=((a&0xf0000)>>16)*10000 ;
	 q +=((a&0xf00000)>>20)*100000 ;
	 q +=((a&0xf000000)>>24)*1000000 ;
	 q +=((a&0xf0000000)>>28)*10000000 ;
	 return( q ) ;
}

/////////////// bin to bcd function (4digit)
int binbcd(int a)
{ 
	 int q,tmp; 
	 q = ( a % 10);   // 1
	 tmp = a / 10;
	 q |= ( (tmp % 10) ) << 4; // 10  
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 8; // 100
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 12; // 1000
	 return (q);
} 

/////////////// bin to bcd function (8digit)
long bin8bcd(long a)
{
	 int q,tmp; 
	 q = ( a % 10);   // 1
	 tmp = a / 10;
	 q |= ( (tmp % 10) ) << 4; // 10  
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 8; // 100
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 12; // 1000
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 16; // 10000 
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 20; // 100000 
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 24; // 1000000 
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 28; // 10000000 
	 return (q); 
}

