//   Professional File

////////////////////////////////////////////////////
// RenriVer 8.74  DllLibrary Arduino  0.05         //
// c source builder by  SEQ_CBuilder V             //
// TargetCPU = ESP32(WROOM32) Library=M5Stack      //
// make   SROTSRIN.h File  2020/02/05 09:55  //
////////////////////////////////////////////////////
unsigned  char sysParam;
#define X0021 	 (0x01 << 0) 
#define X0022 	 (0x01 << 1) 
byte in_no[] = { 21 , 22}; 

#define   GET_X(DEVICE,NO) 	 (in_data & DEVICE)

#define   _INXUPPER_  (22) 

 #define M0010 	 (0x01 << (10 % 16) ) 
#define M0020 	 (0x01 << (20 % 16) ) 

#define GET_M(DEVICE,NO) 	 (m_relay[ NO / 16 ] & DEVICE)
#define SET_M_ON(DEVICE,NO) 	 m_relay[ NO / 16 ] = m_relay[ NO / 16 ] | DEVICE
#define SET_M_OFF(DEVICE,NO) 	 m_relay[ NO / 16 ] = m_relay[ NO / 16 ] & ~DEVICE

#define M_GET_STATUS(NO)   ( (m_relay[NO/16] & (0x01 << (NO))) ? 1 : 0 )
#define M_ARRAY(NO)       (m_relay[NO/16]) 
#define PTRM_ARRAY(NO)       (&m_relay[NO/16])
#define M_UB_ARRAY(NO)   (((unsigned char*)&m_relay[NO/16])+1)
#define M_LB_ARRAY(NO)   (((unsigned char*)&m_relay[NO/16]))
unsigned short m_relay[2]; // 

#define   _MUPPER_  (20) 

 #define D0000 	 (d_data[0] ) 
#define D0020 	 (d_data[20] ) 
#define GET_D(DEVICE,NO) 	 ( DEVICE )
#define SET_D(DEVICE,NO,DATA) 	 ( DEVICE ) = (DATA) 

#define D_VARIABLE(NO)   (d_data[NO])
#define D_UB_ARRAY(NO)   (((unsigned char*)&d_data[NO])+1)
#define D_LB_ARRAY(NO)   (((unsigned char*)&d_data[NO]))
#define D_ARRAY(NO)     (d_data[NO])
#define PTRD_ARRAY(NO)    (&d_data[NO])
short d_data[21]; // 

#define   _DATAUPPER_  (20) 

// 使用する変数やマクロの宣言部

#define M9010   (0x01 << 0)   //  Errorフラグ
#define M9012   (0x01 << 1)   //  Carryフラグ
#define M9013   (0x01 << 2)   //  0(ゼロ)フラグ
#define M9030   (0x01 << 3)   // ０．１秒クロックパルス
#define M9031   (0x01 << 4)   // ０．２秒クロックパルス
#define M9032   (0x01 << 5)  // １．０秒クロックパルス
#define M9033   (0x01 << 6)  // ２．０秒クロックパルス
#define M9034   (0x01 << 7)  // ３０．０秒クロックパルス
#define M9038   (0x01 << 8)  // １－Ｓｃａｎ　On
#define M9036   (0x01 << 9)  // 常時　On　リレー
#define M9037   (0x01 << 10)  // 常時　ＯＦＦ　リレー
#define M9035   (0x01 << 11)  // 0.01秒　クロックパルス
#define M9003   (0x01 << 12) // 継続命令フラグ
#define M9039   (0x01 << 13)  // 0.005秒　クロックパルス
#define M9040   (0x01 << 16)  // シリアル通信受信完了フラグ
#define M9041   (0x01 << 17)  // シリアル通信受信エラーフラグ
#define GET_E(DEVICE,NO)    (tokreg & DEVICE)
#define SET_E_ON(DEVICE,NO)  tokreg = tokreg | DEVICE
#define SET_E_OFF(DEVICE,NO)  tokreg = tokreg & ~DEVICE
unsigned long  tokreg; // 特殊リレー用変数

unsigned long starttime;
unsigned long lasttime;
unsigned long spantime;
unsigned long maxspantime;
unsigned long minspantime;
unsigned long lasttime_ms;
unsigned long spantime_ms;

unsigned long systemtime;
unsigned long systemtimes;
unsigned long systemtime10ms;
unsigned long in_data ;  // 入力Ｘの保持変数（３２点数分）
unsigned long out_data ;  // 出力Ｙの保持変数（３２点数分）

unsigned int  ldlg; // ブロック用変数
unsigned int  aax; // 回路の状態保持変数
unsigned int  iix;  // ＭＣの状態保持用変数
unsigned int  q;
unsigned int  trlg; // ＭＰＳ／ＭＲＤ／ＭＰＰ
byte        mcflg;  // ＭＣのフラグ
int			flag;


int bcdbin(int a);
int bcd8bin(int a);
int binbcd(int a);
int bin8bcd(int a);
// // // LD b0 D0 B1 P0 F0 L0 BIN0 X0021 0 0 
 // // // // // SROT b0 D0 B0 P0 F0 L1 BIN0 K0020 D0000 M0010 11 0 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 X0022 0 1 
 // // // // // SRIN b0 D0 B0 P0 F0 L1 BIN0 K0020 D0020 M0020 11 1 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 M8000 0 2 
 // // // OUTR b0 D0 B0 P0 F0 L0 BIN0 M8005 11 2 
 // // END b0 D0 B1 P0 F0 L0 BIN0 11 3 
 // standard function
	
void input_refresh() {
	 	 for (byte i=0; i<sizeof(in_no); i++) { 
	 	 	 if (digitalRead(in_no[i])==HIGH) { 
	 	 	 	 in_data = in_data & ~(0x01 << i);
	 	 	 } else { 
	 	 	 	 in_data = in_data | (0x01 << i);
	 	 	 }
	 	 }
} 
	 
// リンクリフレッシュ関数宣言部(将来のために用意)
void link_refresh()
{
	 
}
// タイマーの時間経過関数宣言部
void time_refresh() {
	 unsigned long nowtime; 
	 nowtime = micros(); 
	 spantime = nowtime - lasttime;
	 lasttime = nowtime;
	 nowtime = millis(); // 電源ＯＮ後の経過時間をmsで取得する
	 if (spantime>maxspantime) maxspantime=spantime;
	 if (spantime<minspantime) minspantime=spantime;
	 spantime_ms = nowtime - lasttime_ms;
	 lasttime_ms = nowtime;
	 
	 
} 
// special_relay refresh 
void special_refresh() {
	 static unsigned long c30s = 0;
// 500ms単位の動作（０．５秒のリレーを作る部分）
	 if ( systemtimes + spantime >= 500000) {
	 	 systemtimes = systemtimes + spantime - 500000;
	 	 if ( GET_E(M9032,0) ){
	 	 	 SET_E_OFF(M9032,0);
	 	 	 if (GET_E(M9033,0)) {
	 	 	 	 SET_E_OFF(M9033,0);
	 	 	 } else {
	 	 	 	 SET_E_ON(M9033,0);
	 	 	 } 
	 	 } else {
	 	 	 SET_E_ON(M9032,0);
	 	 } 
	 	 c30s++; 
	 	 if (c30s>=30){ 
	 	 	 c30s=0; 
	 	 	 if(GET_E(M9034,0)){ 
	 	 	 	 SET_E_OFF(M9034,0); 
	 	 	 } else { 
	 	 	 	 SET_E_ON(M9034,0); 
	 	 	 } 
	 	 } 
	 	  
	 } else { 
	 	 systemtimes += spantime;
	 }

//' 50ms単位の動作（０．１秒のリレーを作る部分）
	 if ( systemtime + spantime >= 50000) { 
	 	 systemtime = systemtime + spantime - 50000;
	 	 if ( GET_E(M9030,0) ){
	 	 	 SET_E_OFF(M9030,0);
	 	 	 if (GET_E(M9031,0)) {
	 	 	 	 SET_E_OFF(M9031,0);
	 	 	 } else { 
	 	 	 	 SET_E_ON(M9031,0);
	 	 	 } 
	 	 } else {
	 	 	 SET_E_ON(M9030,0);
	 	 }
	 } else {
	 	 systemtime += spantime;
	 }
	 
// 5ms単位の動作（０．０１秒のリレーを作る部分）
	 if ( systemtime10ms + spantime >= 5000) {
	 	 systemtime10ms = systemtime10ms + spantime - 5000;
	 	 if ( GET_E(M9035,0) ){
	 	 	 SET_E_OFF(M9035,0);
	 	 	 if (GET_E(M9039,0)) {
	 	 	 	 SET_E_OFF(M9039,0);
	 	 	 } else {
	 	 	 	 SET_E_ON(M9039,0);
	 	 	 }
	 	 } else {
	 	 	 SET_E_ON(M9035,0);
	 	 }
	 } else {
	 	 systemtime10ms += spantime;
	 }
} 
/////////////// bcd to bin function (4digit)
int bcdbin( int a )
{ 
	 int q ;
	 q = a&0x0f ;
	 q +=((a&0xf0)>>4)*10 ;
	 q +=((a&0xf00)>>8)*100 ;
	 q +=((a&0xf000)>>12)*1000 ;
	 return( q ) ;
}
/////////////// bcd to bin function (8digit)
long bcd8bin( long a )
{ 
	 int q ;
	 q = ( a & 0xf );
	 q +=((a&0xf0)>>4)*10 ;
	 q +=((a&0xf00)>>8)*100 ;
	 q +=((a&0xf000)>>12)*1000 ;
	 q +=((a&0xf0000)>>16)*10000 ;
	 q +=((a&0xf00000)>>20)*100000 ;
	 q +=((a&0xf000000)>>24)*1000000 ;
	 q +=((a&0xf0000000)>>28)*10000000 ;
	 return( q ) ;
}

/////////////// bin to bcd function (4digit)
int binbcd(int a)
{ 
	 int q,tmp; 
	 q = ( a % 10);   // 1
	 tmp = a / 10;
	 q |= ( (tmp % 10) ) << 4; // 10  
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 8; // 100
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 12; // 1000
	 return (q);
} 

/////////////// bin to bcd function (8digit)
long bin8bcd(long a)
{
	 int q,tmp; 
	 q = ( a % 10);   // 1
	 tmp = a / 10;
	 q |= ( (tmp % 10) ) << 4; // 10  
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 8; // 100
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 12; // 1000
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 16; // 10000 
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 20; // 100000 
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 24; // 1000000 
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 28; // 10000000 
	 return (q); 
}

