//   Professional File

////////////////////////////////////////////////////
// RenriVer 8.74  DllLibrary Arduino  0.05         //
// c source builder by  SEQ_CBuilder V             //
// TargetCPU = ESP32(WROOM32) Library=M5Stack      //
// make     jrelay.h File  2020/02/03 08:43  //
////////////////////////////////////////////////////
unsigned  char sysParam;
#define X0002 	 (0x01 << 0) 
#define X0005 	 (0x01 << 1) 
byte in_no[] = { 2 , 5}; 

#define   GET_X(DEVICE,NO) 	 (in_data & DEVICE)

#define   _INXUPPER_  (5) 

 #define   MCP_CH7_TRIS   (0x8001)   
#define  X0170  (0x01 << 0) 
#define  Y0177  (0x01 << 7) 
#define  Y0178  (0x01 << 8) 
#define  X017F  (0x01 << 15) 

#define  GET_MCPX(DEVICE,NO) 	 (mcp_data[((NO)>>4) & 0xf] & DEVICE )

#define  SET_MCPY_ON(DEVICE,NO) 	 mcp_data[((NO)>>4) & 0xf]=(mcp_data[((NO)>>4) & 0xf] | DEVICE )

#define  SET_MCPY_OFF(DEVICE,NO) 	 mcp_data[((NO)>>4) & 0xf]=(mcp_data[((NO)>>4) & 0xf] & (~DEVICE) )

unsigned short  mcp_data[8];
#define M0000 	 (0x01 << (0 % 16) ) 
#define M0001 	 (0x01 << (1 % 16) ) 

#define GET_M(DEVICE,NO) 	 (m_relay[ NO / 16 ] & DEVICE)
#define SET_M_ON(DEVICE,NO) 	 m_relay[ NO / 16 ] = m_relay[ NO / 16 ] | DEVICE
#define SET_M_OFF(DEVICE,NO) 	 m_relay[ NO / 16 ] = m_relay[ NO / 16 ] & ~DEVICE

#define M_GET_STATUS(NO)   ( (m_relay[NO/16] & (0x01 << (NO))) ? 1 : 0 )
#define M_ARRAY(NO)       (m_relay[NO/16]) 
#define PTRM_ARRAY(NO)       (&m_relay[NO/16])
#define M_UB_ARRAY(NO)   (((unsigned char*)&m_relay[NO/16])+1)
#define M_LB_ARRAY(NO)   (((unsigned char*)&m_relay[NO/16]))
unsigned short m_relay[1]; // 

#define   _MUPPER_  (1) 

 #define 	 J0000 	 ( 0x0000 )	
#define 	 J0001 	 ( 0x0001 )	
#define 	 J0059 	 ( 0x0059 )	
#define 	 J0063 	 ( 0x0063 )	
#define GET_J(NO) 	 ( (JRelay[ (NO & 0xff00) >> 8] == (NO & 0xff) ) ? 1:0 )
#define SET_J_ON(NO) 	 ( (JRelay[ (NO & 0xff00)>>8]) = (NO & 0xff) ) 
byte JRelay[0x7];

#define   _LUPPER_  (0) 

// 使用する変数やマクロの宣言部

#define M9010   (0x01 << 0)   //  Errorフラグ
#define M9012   (0x01 << 1)   //  Carryフラグ
#define M9013   (0x01 << 2)   //  0(ゼロ)フラグ
#define M9030   (0x01 << 3)   // ０．１秒クロックパルス
#define M9031   (0x01 << 4)   // ０．２秒クロックパルス
#define M9032   (0x01 << 5)  // １．０秒クロックパルス
#define M9033   (0x01 << 6)  // ２．０秒クロックパルス
#define M9034   (0x01 << 7)  // ３０．０秒クロックパルス
#define M9038   (0x01 << 8)  // １－Ｓｃａｎ　On
#define M9036   (0x01 << 9)  // 常時　On　リレー
#define M9037   (0x01 << 10)  // 常時　ＯＦＦ　リレー
#define M9035   (0x01 << 11)  // 0.01秒　クロックパルス
#define M9003   (0x01 << 12) // 継続命令フラグ
#define M9039   (0x01 << 13)  // 0.005秒　クロックパルス
#define GET_E(DEVICE,NO)    (tokreg & DEVICE)
#define SET_E_ON(DEVICE,NO)  tokreg = tokreg | DEVICE
#define SET_E_OFF(DEVICE,NO)  tokreg = tokreg & ~DEVICE
unsigned long  tokreg; // 特殊リレー用変数

unsigned long starttime;
unsigned long lasttime;
unsigned long spantime;
unsigned long maxspantime;
unsigned long minspantime;
unsigned long lasttime_ms;
unsigned long spantime_ms;

unsigned long systemtime;
unsigned long systemtimes;
unsigned long systemtime10ms;
unsigned long in_data ;  // 入力Ｘの保持変数（３２点数分）
unsigned long out_data ;  // 出力Ｙの保持変数（３２点数分）

unsigned int  ldlg; // ブロック用変数
unsigned int  aax; // 回路の状態保持変数
unsigned int  iix;  // ＭＣの状態保持用変数
unsigned int  q;
unsigned int  trlg; // ＭＰＳ／ＭＲＤ／ＭＰＰ
byte        mcflg;  // ＭＣのフラグ
int			flag;


int bcdbin(int a);
int bcd8bin(int a);
int binbcd(int a);
int bin8bcd(int a);
// MCP23008 初期化処理 
void initMCP(byte address, byte direct) {
	 Wire.begin();

	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x00);    // 入出力IO方向レジスタの番地
	 Wire.write(direct);	// 入出力IO方向レジスタの値
	 Wire.write(direct); // 論理の反転レジスタの値
	 Wire.endTransmission();

	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x06);	// プルアップのレジスタの番地
	 Wire.write(direct);	// プルアップのレジスタ
	 Wire.endTransmission();

	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x09);
	 Wire.write(direct); 	// PORTのIOレジスタ
	 Wire.write(direct);	// LATCHのレジスタ 
	 Wire.endTransmission();
}


// MCP23017 初期化処理
void initMCP(byte address, unsigned short direct) {
	 Wire.begin();

	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x00);	// 入出力IO方向レジスタの番地
	 Wire.write(direct & 0xff);	// 入出力IO方向レジスタの値 A
	 Wire.write((direct>>8) & 0xff);	//  入出力IO方向レジスタの値 B
	 Wire.write(direct & 0xff); // 論理の反転レジスタの値 A
	 Wire.write((direct>>8) & 0xff); // 論理の反転レジスタの値 B
	 Wire.endTransmission();

	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x0C);	// 
	 Wire.write(direct & 0xff);	// プルアップのレジスタ A
	 Wire.write((direct>>8) & 0xff); // プルアップのレジスタ B
	 Wire.endTransmission();

	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x12);
	 Wire.write(direct & 0xff);	// PORTAのIOレジスタ
	 Wire.write((direct>>8) & 0xff);// PORTBのIOレジスタ
	 Wire.write(direct & 0xff);	// LATCHAのレジスタ
	 Wire.write((direct>>8) & 0xff);	// LATCHBのレジスタ
	 Wire.endTransmission();
}

byte readMCP(byte address,byte direct) {
	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x09);
	 Wire.endTransmission();
	 Wire.requestFrom(0x20 | address,1);
	 byte recvdata = Wire.read();
	 Wire.endTransmission();
	 recvdata = recvdata & direct;
	 return recvdata;
}

unsigned short readMCP(byte address,unsigned short direct) {
	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x12);
	 Wire.endTransmission();
	 Wire.requestFrom(0x20 | address,2);
	 unsigned short recvdata = Wire.read();
	 recvdata = recvdata | ((unsigned short)Wire.read() << 8);
	 Wire.endTransmission();
	 recvdata = recvdata & direct;
	 return recvdata;
}

void writeMCP(byte address,byte direct,byte writedata) {
	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x09);
	 Wire.write(writedata);
	 Wire.endTransmission();
}

void writeMCP(byte address,unsigned short direct,unsigned short writedata) {
	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x12);
	 Wire.write(writedata & 0xff);
	 Wire.write((writedata>>8) & 0xff);
	 Wire.write(writedata & 0xff);
	 Wire.write((writedata>>8) & 0xff);
	 Wire.endTransmission();
}

// // // LD b0 D0 B1 P0 F0 L0 BIN0 X0170 0 0 
 // // // OR b0 D0 B0 P0 F0 L0 BIN0 X0002 0 1 
 // // // ANI b0 D0 B0 P0 F0 L0 BIN0 X017F 1 0 
 // // MPS b0 D0 B0 P0 F0 L0 BIN0 2 0 
 // // // OUTR b0 D0 B0 P0 F0 L0 BIN0 M0000 11 0 
 // // // OUTR b0 D0 B0 P0 F0 L0 BIN0 J0000 11 1 
 // // MPP b0 D0 B0 P0 F0 L0 BIN0 2 0 
 // // // OUTR b0 D0 B0 P0 F0 L0 BIN0 J0063 11 2 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 X017F 0 3 
 // // // OR b0 D0 B0 P0 F0 L0 BIN0 X0005 0 4 
 // // // ANI b0 D0 B0 P0 F0 L0 BIN0 X0170 1 3 
 // // MPS b0 D0 B0 P0 F0 L0 BIN0 2 4 
 // // // OUTR b0 D0 B0 P0 F0 L0 BIN0 M0001 27 3 
 // // // OUTR b0 D0 B0 P0 F0 L0 BIN0 J0001 27 5 
 // // MPP b0 D0 B0 P0 F0 L0 BIN0 2 4 
 // // // OUTR b0 D0 B0 P0 F0 L0 BIN0 J0059 27 6 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 J0059 16 6 
 // // // OUTR b0 D0 B0 P0 F0 L0 BIN0 Y0177 27 6 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 J0063 16 7 
 // // // OUTR b0 D0 B0 P0 F0 L0 BIN0 Y0178 27 7 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 M8000 16 8 
 // // // OUTR b0 D0 B0 P0 F0 L0 BIN0 M8005 27 8 
 // // END b0 D0 B1 P0 F0 L0 BIN0 27 9 
 // standard function
	
void input_refresh() {
	 	 for (byte i=0; i<sizeof(in_no); i++) { 
	 	 	 if (digitalRead(in_no[i])==HIGH) { 
	 	 	 	 in_data = in_data & ~(0x01 << i);
	 	 	 } else { 
	 	 	 	 in_data = in_data | (0x01 << i);
	 	 	 }
	 	 }
} 
	 
	
void mcp_refresh() {
	 mcp_data[7] = (mcp_data[7] & (~MCP_CH7_TRIS)) | (readMCP(7,(unsigned short)MCP_CH7_TRIS) );
	 writeMCP( 7 , (unsigned short)MCP_CH7_TRIS , (unsigned short)mcp_data[7] );
}
// リンクリフレッシュ関数宣言部(将来のために用意)
void link_refresh()
{
	 
}
// タイマーの時間経過関数宣言部
void time_refresh() {
	 unsigned long nowtime; 
	 nowtime = micros(); 
	 spantime = nowtime - lasttime;
	 lasttime = nowtime;
	 nowtime = millis(); // 電源ＯＮ後の経過時間をmsで取得する
	 if (spantime>maxspantime) maxspantime=spantime;
	 if (spantime<minspantime) minspantime=spantime;
	 spantime_ms = nowtime - lasttime_ms;
	 lasttime_ms = nowtime;
	 
	 
} 
// special_relay refresh 
void special_refresh() {
	 static unsigned long c30s = 0;
// 500ms単位の動作（０．５秒のリレーを作る部分）
	 if ( systemtimes + spantime >= 500000) {
	 	 systemtimes = systemtimes + spantime - 500000;
	 	 if ( GET_E(M9032,0) ){
	 	 	 SET_E_OFF(M9032,0);
	 	 	 if (GET_E(M9033,0)) {
	 	 	 	 SET_E_OFF(M9033,0);
	 	 	 } else {
	 	 	 	 SET_E_ON(M9033,0);
	 	 	 } 
	 	 } else {
	 	 	 SET_E_ON(M9032,0);
	 	 } 
	 	 c30s++; 
	 	 if (c30s>=30){ 
	 	 	 c30s=0; 
	 	 	 if(GET_E(M9034,0)){ 
	 	 	 	 SET_E_OFF(M9034,0); 
	 	 	 } else { 
	 	 	 	 SET_E_ON(M9034,0); 
	 	 	 } 
	 	 } 
	 	  
	 } else { 
	 	 systemtimes += spantime;
	 }

//' 50ms単位の動作（０．１秒のリレーを作る部分）
	 if ( systemtime + spantime >= 50000) { 
	 	 systemtime = systemtime + spantime - 50000;
	 	 if ( GET_E(M9030,0) ){
	 	 	 SET_E_OFF(M9030,0);
	 	 	 if (GET_E(M9031,0)) {
	 	 	 	 SET_E_OFF(M9031,0);
	 	 	 } else { 
	 	 	 	 SET_E_ON(M9031,0);
	 	 	 } 
	 	 } else {
	 	 	 SET_E_ON(M9030,0);
	 	 }
	 } else {
	 	 systemtime += spantime;
	 }
	 
// 5ms単位の動作（０．０１秒のリレーを作る部分）
	 if ( systemtime10ms + spantime >= 5000) {
	 	 systemtime10ms = systemtime10ms + spantime - 5000;
	 	 if ( GET_E(M9035,0) ){
	 	 	 SET_E_OFF(M9035,0);
	 	 	 if (GET_E(M9039,0)) {
	 	 	 	 SET_E_OFF(M9039,0);
	 	 	 } else {
	 	 	 	 SET_E_ON(M9039,0);
	 	 	 }
	 	 } else {
	 	 	 SET_E_ON(M9035,0);
	 	 }
	 } else {
	 	 systemtime10ms += spantime;
	 }
} 
/////////////// bcd to bin function (4digit)
int bcdbin( int a )
{ 
	 int q ;
	 q = a&0x0f ;
	 q +=((a&0xf0)>>4)*10 ;
	 q +=((a&0xf00)>>8)*100 ;
	 q +=((a&0xf000)>>12)*1000 ;
	 return( q ) ;
}
/////////////// bcd to bin function (8digit)
long bcd8bin( long a )
{ 
	 int q ;
	 q = ( a & 0xf );
	 q +=((a&0xf0)>>4)*10 ;
	 q +=((a&0xf00)>>8)*100 ;
	 q +=((a&0xf000)>>12)*1000 ;
	 q +=((a&0xf0000)>>16)*10000 ;
	 q +=((a&0xf00000)>>20)*100000 ;
	 q +=((a&0xf000000)>>24)*1000000 ;
	 q +=((a&0xf0000000)>>28)*10000000 ;
	 return( q ) ;
}

/////////////// bin to bcd function (4digit)
int binbcd(int a)
{ 
	 int q,tmp; 
	 q = ( a % 10);   // 1
	 tmp = a / 10;
	 q |= ( (tmp % 10) ) << 4; // 10  
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 8; // 100
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 12; // 1000
	 return (q);
} 

/////////////// bin to bcd function (8digit)
long bin8bcd(long a)
{
	 int q,tmp; 
	 q = ( a % 10);   // 1
	 tmp = a / 10;
	 q |= ( (tmp % 10) ) << 4; // 10  
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 8; // 100
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 12; // 1000
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 16; // 10000 
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 20; // 100000 
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 24; // 1000000 
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 28; // 10000000 
	 return (q); 
}

