//   Professional File

////////////////////////////////////////////////////
// RenriVer 8.74  DllLibrary Arduino  0.05         //
// c source builder by  SEQ_CBuilder V             //
// TargetCPU = ESP32(WROOM32) Library=M5Stack      //
// make kakuspii2c.h File  2020/02/13 15:19  //
////////////////////////////////////////////////////
unsigned  char sysParam;
#define   MCP_CH7_TRIS   (0x8001)   
#define  X0170  (0x01 << 0) 
#define  Y0177  (0x01 << 7) 
#define  Y0178  (0x01 << 8) 
#define  X017F  (0x01 << 15) 

#define  GET_MCPX(DEVICE,NO) 	 (mcp_data[((NO)>>4) & 0xf] & DEVICE )

#define  SET_MCPY_ON(DEVICE,NO) 	 mcp_data[((NO)>>4) & 0xf]=(mcp_data[((NO)>>4) & 0xf] | DEVICE )

#define  SET_MCPY_OFF(DEVICE,NO) 	 mcp_data[((NO)>>4) & 0xf]=(mcp_data[((NO)>>4) & 0xf] & (~DEVICE) )

unsigned short  mcp_data[8];
#define Y0026 	 (0x01 << 0) 
byte out_no[] = { 26}; 

#define GET_Y(DEVICE,NO) 	 (out_data & DEVICE)
#define SET_Y_ON(DEVICE,NO) 	 out_data = out_data | DEVICE
#define SET_Y_OFF(DEVICE,NO) 	 out_data = out_data & ~DEVICE

#define   _OUTYUPPER_  (26) 

 #define D0024 	 (d_data[24] ) 
#define D0026 	 (d_data[26] ) 
#define D0027 	 (d_data[27] ) 
#define D0028 	 (d_data[28] ) 
#define D0029 	 (d_data[29] ) 
#define GET_D(DEVICE,NO) 	 ( DEVICE )
#define SET_D(DEVICE,NO,DATA) 	 ( DEVICE ) = (DATA) 

#define D_VARIABLE(NO)   (d_data[NO])
#define D_UB_ARRAY(NO)   (((unsigned char*)&d_data[NO])+1)
#define D_LB_ARRAY(NO)   (((unsigned char*)&d_data[NO]))
#define D_ARRAY(NO)     (d_data[NO])
#define PTRD_ARRAY(NO)    (&d_data[NO])
short d_data[30]; // 

#define   _DATAUPPER_  (29) 

// 使用する変数やマクロの宣言部

#define M9010   (0x01 << 0)   //  Errorフラグ
#define M9012   (0x01 << 1)   //  Carryフラグ
#define M9013   (0x01 << 2)   //  0(ゼロ)フラグ
#define M9030   (0x01 << 3)   // ０．１秒クロックパルス
#define M9031   (0x01 << 4)   // ０．２秒クロックパルス
#define M9032   (0x01 << 5)  // １．０秒クロックパルス
#define M9033   (0x01 << 6)  // ２．０秒クロックパルス
#define M9034   (0x01 << 7)  // ３０．０秒クロックパルス
#define M9038   (0x01 << 8)  // １－Ｓｃａｎ　On
#define M9036   (0x01 << 9)  // 常時　On　リレー
#define M9037   (0x01 << 10)  // 常時　ＯＦＦ　リレー
#define M9035   (0x01 << 11)  // 0.01秒　クロックパルス
#define M9003   (0x01 << 12) // 継続命令フラグ
#define M9039   (0x01 << 13)  // 0.005秒　クロックパルス
#define M9040   (0x01 << 16)  // シリアル通信受信完了フラグ
#define M9041   (0x01 << 17)  // シリアル通信受信エラーフラグ
#define GET_E(DEVICE,NO)    (tokreg & DEVICE)
#define SET_E_ON(DEVICE,NO)  tokreg = tokreg | DEVICE
#define SET_E_OFF(DEVICE,NO)  tokreg = tokreg & ~DEVICE
unsigned long  tokreg; // 特殊リレー用変数

unsigned long starttime;
unsigned long lasttime;
unsigned long spantime;
unsigned long maxspantime;
unsigned long minspantime;
unsigned long lasttime_ms;
unsigned long spantime_ms;

unsigned long systemtime;
unsigned long systemtimes;
unsigned long systemtime10ms;
unsigned long in_data ;  // 入力Ｘの保持変数（３２点数分）
unsigned long out_data ;  // 出力Ｙの保持変数（３２点数分）

unsigned int  ldlg; // ブロック用変数
unsigned int  aax; // 回路の状態保持変数
unsigned int  iix;  // ＭＣの状態保持用変数
unsigned int  q;
unsigned int  trlg; // ＭＰＳ／ＭＲＤ／ＭＰＰ
byte        mcflg;  // ＭＣのフラグ
int			flag;


int bcdbin(int a);
int bcd8bin(int a);
int binbcd(int a);
int bin8bcd(int a);
// MCP23008 初期化処理 
void initMCP(byte address, byte direct) {
	 Wire.begin();

	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x00);    // 入出力IO方向レジスタの番地
	 Wire.write(direct);	// 入出力IO方向レジスタの値
	 Wire.write(direct); // 論理の反転レジスタの値
	 Wire.endTransmission();

	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x06);	// プルアップのレジスタの番地
	 Wire.write(direct);	// プルアップのレジスタ
	 Wire.endTransmission();

	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x09);
	 Wire.write(direct); 	// PORTのIOレジスタ
	 Wire.write(direct);	// LATCHのレジスタ 
	 Wire.endTransmission();
}


// MCP23017 初期化処理
void initMCP(byte address, unsigned short direct) {
	 Wire.begin();

	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x00);	// 入出力IO方向レジスタの番地
	 Wire.write(direct & 0xff);	// 入出力IO方向レジスタの値 A
	 Wire.write((direct>>8) & 0xff);	//  入出力IO方向レジスタの値 B
	 Wire.write(direct & 0xff); // 論理の反転レジスタの値 A
	 Wire.write((direct>>8) & 0xff); // 論理の反転レジスタの値 B
	 Wire.endTransmission();

	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x0C);	// 
	 Wire.write(direct & 0xff);	// プルアップのレジスタ A
	 Wire.write((direct>>8) & 0xff); // プルアップのレジスタ B
	 Wire.endTransmission();

	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x12);
	 Wire.write(direct & 0xff);	// PORTAのIOレジスタ
	 Wire.write((direct>>8) & 0xff);// PORTBのIOレジスタ
	 Wire.write(direct & 0xff);	// LATCHAのレジスタ
	 Wire.write((direct>>8) & 0xff);	// LATCHBのレジスタ
	 Wire.endTransmission();
}

byte readMCP(byte address,byte direct) {
	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x09);
	 Wire.endTransmission();
	 Wire.requestFrom(0x20 | address,1);
	 byte recvdata = Wire.read();
	 Wire.endTransmission();
	 recvdata = recvdata & direct;
	 return recvdata;
}

unsigned short readMCP(byte address,unsigned short direct) {
	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x12);
	 Wire.endTransmission();
	 Wire.requestFrom(0x20 | address,2);
	 unsigned short recvdata = Wire.read();
	 recvdata = recvdata | ((unsigned short)Wire.read() << 8);
	 Wire.endTransmission();
	 recvdata = recvdata & direct;
	 return recvdata;
}

void writeMCP(byte address,byte direct,byte writedata) {
	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x09);
	 Wire.write(writedata);
	 Wire.endTransmission();
}

void writeMCP(byte address,unsigned short direct,unsigned short writedata) {
	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x12);
	 Wire.write(writedata & 0xff);
	 Wire.write((writedata>>8) & 0xff);
	 Wire.write(writedata & 0xff);
	 Wire.write((writedata>>8) & 0xff);
	 Wire.endTransmission();
}

void InstSet(byte address, byte sendbyte) {			
   Wire.begin();
   Wire.beginTransmission(address);
   Wire.write(0x0);
   Wire.write(sendbyte);    // FUNCTION SET 8bit,N=1,5*7dot 
   Wire.endTransmission();
   delayMicroseconds(30);
}


void WriteChar(byte address,char sendbyte){
   Wire.begin();
   Wire.beginTransmission(address);
   Wire.write(0x40);
   Wire.write(sendbyte);    // FUNCTION SET 8bit,N=1,5*7dot 
   Wire.endTransmission();
   delayMicroseconds(30);    
}

void WriteStr(byte address,char *sendbyte){
   while(*sendbyte!=0){
     if((*sendbyte=='\r') || (*sendbyte=='\n')){
       InstSet(address,0x40|0x80);     
     } else {
       Wire.begin();
       Wire.beginTransmission(address);
       Wire.write(0x40);
       Wire.write(*sendbyte);    // FUNCTION SET 8bit,N=1,5*7dot       
       Wire.endTransmission();
       delayMicroseconds(30);   
     }
     sendbyte++;
   }
}

void initTFT(byte address){	 InstSet(address,0x38);    // FUNCTION SET 8bit,N=1,5*7dot 
	 InstSet(address,0x39);    // FUNCTION SET 8bit,N=1,5*7dot 
	 InstSet(address,0x14);     //  Internal OSC frequency adjustment
	 InstSet(address,0x73);     //  Contrast set
	 InstSet(address,0x56);     //  Power/ICON/Contrast control
	 InstSet(address,0x6C);     //   Follower control
	 delay(200);
	 InstSet(address,0x38);     //  Display ON
	 InstSet(address,0x01);      //  CLEAR DISPLAY
	 delay(2);
	 InstSet(address,0x0C);     //  
	 WriteChar(address,'A');   // 
	 WriteChar(address,'B');
	 WriteStr(address,"\nTEST\n");
} 
// // // LD b0 D0 B1 P0 F0 L0 BIN0 M9038 0 0 
 // // MPS b0 D0 B0 P0 F0 L0 BIN0 1 0 
 // // STATS b0 D0 B0 P0 F0 L0 BIN0 11 0 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0046 Y0026 11 1 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0000 Y0026 11 2 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0044 Y0026 11 3 
 // // MPP b0 D0 B0 P0 F0 L0 BIN0 1 0 
 // // STOPS b0 D0 B0 P0 F0 L0 BIN0 11 4 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 M9038 0 5 
 // // MPS b0 D0 B0 P0 F0 L0 BIN0 1 5 
 // // STATS b0 D0 B0 P0 F0 L0 BIN0 11 5 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0046 Y0026 11 6 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0006 Y0026 11 7 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0044 Y0026 11 8 
 // // MPP b0 D0 B0 P0 F0 L0 BIN0 1 5 
 // // STOPS b0 D0 B0 P0 F0 L0 BIN0 11 9 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 M9038 0 10 
 // // MPS b0 D0 B0 P0 F0 L0 BIN0 1 10 
 // // STATS b0 D0 B0 P0 F0 L0 BIN0 11 10 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0046 Y0026 11 11 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0009 Y0026 11 12 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0044 Y0026 11 13 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0044 Y0026 11 14 
 // // MPP b0 D0 B0 P0 F0 L0 BIN0 1 10 
 // // STOPS b0 D0 B0 P0 F0 L0 BIN0 11 15 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 X0170 0 16 
 // // // OR b0 D0 B0 P0 F0 L0 BIN0 Y0177 0 17 
 // // // ANI b0 D0 B0 P0 F0 L0 BIN0 X017F 1 16 
 // // // OUTR b0 D0 B0 P0 F0 L0 BIN0 Y0177 11 16 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 X017F 0 18 
 // // // OR b0 D0 B0 P0 F0 L0 BIN0 Y0178 0 19 
 // // // ANI b0 D0 B0 P0 F0 L0 BIN0 X0170 1 18 
 // // // OUTR b0 D0 B0 P0 F0 L0 BIN0 Y0178 11 18 
 // // // LDI b0 D0 B1 P0 F0 L0 BIN0 X0170 0 20 
 // // MPS b0 D0 B0 P0 F0 L0 BIN0 1 20 
 // // STATS b0 D0 B0 P0 F0 L0 BIN0 11 20 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0046 Y0026 11 21 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0009 Y0026 11 22 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0045 Y0026 11 23 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0045 Y0026 11 24 
 // // MPP b0 D0 B0 P0 F0 L0 BIN0 1 20 
 // // STOPS b0 D0 B0 P0 F0 L0 BIN0 11 25 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 X0170 0 26 
 // // MPS b0 D0 B0 P0 F0 L0 BIN0 1 26 
 // // STATS b0 D0 B0 P0 F0 L0 BIN0 11 26 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0046 Y0026 11 27 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0009 Y0026 11 28 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0046 Y0026 11 29 
 // // // // // WSPDO b0 D0 B0 P0 F0 L3 BIN0 K0008 K0046 Y0026 11 30 
 // // MPP b0 D0 B0 P0 F0 L0 BIN0 1 26 
 // // STOPS b0 D0 B0 P0 F0 L0 BIN0 11 31 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 X0170 0 32 
 // // MPS b0 D0 B0 P0 F0 L0 BIN0 1 32 
 // // // // MOV b0 D0 B0 P0 F0 L1 BIN1 H9876 D0024 11 32 
 // // // // BCDDA b0 D0 B0 P0 F0 L0 BIN0 D0024 D0026 11 33 
 // // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D0026 D0028 11 34 
 // // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D0027 D0029 11 35 
 // // MPP b0 D0 B0 P0 F0 L0 BIN0 1 32 
 // // // // SUP0 b0 D0 B0 P0 F0 L2 BIN0 D0028 K0002 11 36 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 X0170 0 37 
 // // MPS b0 D0 B0 P0 F0 L0 BIN0 1 37 
 // // // // // LCDH b0 D0 B0 P0 F0 L1 BIN0 K0004 D0026 Y002C 11 37 
 // // MPP b0 D0 B0 P0 F0 L0 BIN0 1 37 
 // // // // // LCDL b0 D0 B0 P0 F0 L1 BIN0 K0004 D0028 Y002C 11 38 
 // // // LDI b0 D0 B1 P0 F0 L0 BIN0 X0170 0 39 
 // // MPS b0 D0 B0 P0 F0 L0 BIN0 1 39 
 // // // // MOV b0 D0 B0 P0 F0 L1 BIN1 H1234 D0024 11 39 
 // // // // BCDDA b0 D0 B0 P0 F0 L0 BIN0 D0024 D0026 11 40 
 // // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D0026 D0028 11 41 
 // // // // MOV b0 D0 B0 P0 F0 L0 BIN0 D0027 D0029 11 42 
 // // MPP b0 D0 B0 P0 F0 L0 BIN0 1 39 
 // // // // SUP0 b0 D0 B0 P0 F0 L2 BIN0 D0028 K0002 11 43 
 // // // LDI b0 D0 B1 P0 F0 L0 BIN0 X0170 0 44 
 // // MPS b0 D0 B0 P0 F0 L0 BIN0 1 44 
 // // // // // LCDH b0 D0 B0 P0 F0 L1 BIN0 K0004 D0026 Y002C 11 44 
 // // MPP b0 D0 B0 P0 F0 L0 BIN0 1 44 
 // // // // // LCDL b0 D0 B0 P0 F0 L1 BIN0 K0004 D0028 Y002C 11 45 
 // // // LD b0 D0 B1 P0 F0 L0 BIN0 M8000 0 46 
 // // // OUTR b0 D0 B0 P0 F0 L0 BIN0 M8005 11 46 
 // // END b0 D0 B1 P0 F0 L0 BIN0 11 47 
 // standard function
	
void mcp_refresh() {
	 mcp_data[7] = (mcp_data[7] & (~MCP_CH7_TRIS)) | (readMCP(7,(unsigned short)MCP_CH7_TRIS) );
	 writeMCP( 7 , (unsigned short)MCP_CH7_TRIS , (unsigned short)mcp_data[7] );
}
void output_refresh() {
	 for (byte i=0; i<sizeof( out_no ); i++) { 
	 	 if ( out_data & (0x01 << i) ) {
	 	 	 digitalWrite( out_no[i], HIGH );
	 	 } else {
	 	 	 digitalWrite( out_no[i] , LOW );
	 	 }
	 }
}
// リンクリフレッシュ関数宣言部(将来のために用意)
void link_refresh()
{
	 
}
// タイマーの時間経過関数宣言部
void time_refresh() {
	 unsigned long nowtime; 
	 nowtime = micros(); 
	 spantime = nowtime - lasttime;
	 lasttime = nowtime;
	 nowtime = millis(); // 電源ＯＮ後の経過時間をmsで取得する
	 if (spantime>maxspantime) maxspantime=spantime;
	 if (spantime<minspantime) minspantime=spantime;
	 spantime_ms = nowtime - lasttime_ms;
	 lasttime_ms = nowtime;
	 
	 
} 
// special_relay refresh 
void special_refresh() {
	 static unsigned long c30s = 0;
// 500ms単位の動作（０．５秒のリレーを作る部分）
	 if ( systemtimes + spantime >= 500000) {
	 	 systemtimes = systemtimes + spantime - 500000;
	 	 if ( GET_E(M9032,0) ){
	 	 	 SET_E_OFF(M9032,0);
	 	 	 if (GET_E(M9033,0)) {
	 	 	 	 SET_E_OFF(M9033,0);
	 	 	 } else {
	 	 	 	 SET_E_ON(M9033,0);
	 	 	 } 
	 	 } else {
	 	 	 SET_E_ON(M9032,0);
	 	 } 
	 	 c30s++; 
	 	 if (c30s>=30){ 
	 	 	 c30s=0; 
	 	 	 if(GET_E(M9034,0)){ 
	 	 	 	 SET_E_OFF(M9034,0); 
	 	 	 } else { 
	 	 	 	 SET_E_ON(M9034,0); 
	 	 	 } 
	 	 } 
	 	  
	 } else { 
	 	 systemtimes += spantime;
	 }

//' 50ms単位の動作（０．１秒のリレーを作る部分）
	 if ( systemtime + spantime >= 50000) { 
	 	 systemtime = systemtime + spantime - 50000;
	 	 if ( GET_E(M9030,0) ){
	 	 	 SET_E_OFF(M9030,0);
	 	 	 if (GET_E(M9031,0)) {
	 	 	 	 SET_E_OFF(M9031,0);
	 	 	 } else { 
	 	 	 	 SET_E_ON(M9031,0);
	 	 	 } 
	 	 } else {
	 	 	 SET_E_ON(M9030,0);
	 	 }
	 } else {
	 	 systemtime += spantime;
	 }
	 
// 5ms単位の動作（０．０１秒のリレーを作る部分）
	 if ( systemtime10ms + spantime >= 5000) {
	 	 systemtime10ms = systemtime10ms + spantime - 5000;
	 	 if ( GET_E(M9035,0) ){
	 	 	 SET_E_OFF(M9035,0);
	 	 	 if (GET_E(M9039,0)) {
	 	 	 	 SET_E_OFF(M9039,0);
	 	 	 } else {
	 	 	 	 SET_E_ON(M9039,0);
	 	 	 }
	 	 } else {
	 	 	 SET_E_ON(M9035,0);
	 	 }
	 } else {
	 	 systemtime10ms += spantime;
	 }
} 
/////////////// bcd to bin function (4digit)
int bcdbin( int a )
{ 
	 int q ;
	 q = a&0x0f ;
	 q +=((a&0xf0)>>4)*10 ;
	 q +=((a&0xf00)>>8)*100 ;
	 q +=((a&0xf000)>>12)*1000 ;
	 return( q ) ;
}
/////////////// bcd to bin function (8digit)
long bcd8bin( long a )
{ 
	 int q ;
	 q = ( a & 0xf );
	 q +=((a&0xf0)>>4)*10 ;
	 q +=((a&0xf00)>>8)*100 ;
	 q +=((a&0xf000)>>12)*1000 ;
	 q +=((a&0xf0000)>>16)*10000 ;
	 q +=((a&0xf00000)>>20)*100000 ;
	 q +=((a&0xf000000)>>24)*1000000 ;
	 q +=((a&0xf0000000)>>28)*10000000 ;
	 return( q ) ;
}

/////////////// bin to bcd function (4digit)
int binbcd(int a)
{ 
	 int q,tmp; 
	 q = ( a % 10);   // 1
	 tmp = a / 10;
	 q |= ( (tmp % 10) ) << 4; // 10  
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 8; // 100
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 12; // 1000
	 return (q);
} 

/////////////// bin to bcd function (8digit)
long bin8bcd(long a)
{
	 int q,tmp; 
	 q = ( a % 10);   // 1
	 tmp = a / 10;
	 q |= ( (tmp % 10) ) << 4; // 10  
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 8; // 100
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 12; // 1000
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 16; // 10000 
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 20; // 100000 
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 24; // 1000000 
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 28; // 10000000 
	 return (q); 
}

