//   Professional File

////////////////////////////////////////////////////
// RenriVer 8.74  DllLibrary Arduino  0.05         //
// c source builder by  SEQ_CBuilder V             //
// TargetCPU = ESP32(WROOM32) Library=M5Stack      //
// make tft_cur_outx.h File  2020/02/26 19:06  //
////////////////////////////////////////////////////
// printEfontを使用できるようにするためにヘッダファイルを宣言
// library efont Font Data for Arduino をダウンロードして、Ａｒｄｕｉｎｏに追加してください。
// #include "efontEnableAscii.h"; // 
// #include "efontEnableJa.h"; //  
// #include "efont.h"; // 
// #include "efontESP.h"; // 

#define 	 D9002 	 (nowPageNo)  
#define 	 D9005 	 (menupos)
#define 	 PageMaxCnt 	 5
short lastPageNo = -1; // 前回のページ番号を管理する変数
short nowPageNo = 0;     // 現在のページ番号を管理する変数
short menupos = 0;   // 選択するボタンの変数
short lastmenupos = 0; // 選択するボタンの変数の前回値

unsigned  char sysParam;
#define X0000 	 (0x01 << 0) 
#define X0037 	 (0x01 << 1) 
#define X0038 	 (0x01 << 2) 
#define X0039 	 (0x01 << 3) 
byte in_no[] = { 0 , 37 , 38 , 39}; 

#define   GET_X(DEVICE,NO) 	 (in_data & DEVICE)

#define   _INXUPPER_  (39) 

 
#define  GET_MCPX(DEVICE,NO) 	 (mcp_data[((NO)>>4) & 0xf] & DEVICE )

#define  SET_MCPY_ON(DEVICE,NO) 	 mcp_data[((NO)>>4) & 0xf]=(mcp_data[((NO)>>4) & 0xf] | DEVICE )

#define  SET_MCPY_OFF(DEVICE,NO) 	 mcp_data[((NO)>>4) & 0xf]=(mcp_data[((NO)>>4) & 0xf] & (~DEVICE) )

unsigned short  mcp_data[8];
#define Y0005 	 (0x01 << 0) 
#define Y0025 	 (0x01 << 1) 
#define Y0026 	 (0x01 << 2) 
byte out_no[] = { 5 , 25 , 26}; 

#define GET_Y(DEVICE,NO) 	 (out_data & DEVICE)
#define SET_Y_ON(DEVICE,NO) 	 out_data = out_data | DEVICE
#define SET_Y_OFF(DEVICE,NO) 	 out_data = out_data & ~DEVICE

#define   _OUTYUPPER_  (26) 

 #define M0000 	 (0x01 << (0 % 16) ) 
#define M0001 	 (0x01 << (1 % 16) ) 

#define GET_M(DEVICE,NO) 	 (m_relay[ NO / 16 ] & DEVICE)
#define SET_M_ON(DEVICE,NO) 	 m_relay[ NO / 16 ] = m_relay[ NO / 16 ] | DEVICE
#define SET_M_OFF(DEVICE,NO) 	 m_relay[ NO / 16 ] = m_relay[ NO / 16 ] & ~DEVICE

#define M_GET_STATUS(NO)   ( (m_relay[NO/16] & (0x01 << (NO))) ? 1 : 0 )
#define M_ARRAY(NO)       (m_relay[NO/16]) 
#define PTRM_ARRAY(NO)       (&m_relay[NO/16])
#define M_UB_ARRAY(NO)   (((unsigned char*)&m_relay[NO/16])+1)
#define M_LB_ARRAY(NO)   (((unsigned char*)&m_relay[NO/16]))
unsigned short m_relay[1]; // 

#define   _MUPPER_  (1) 

 #define D0000 	 (d_data[0] ) 
#define D0001 	 (d_data[1] ) 
#define D0002 	 (d_data[2] ) 
#define GET_D(DEVICE,NO) 	 ( DEVICE )
#define SET_D(DEVICE,NO,DATA) 	 ( DEVICE ) = (DATA) 

#define D_VARIABLE(NO)   (d_data[NO])
#define D_UB_ARRAY(NO)   (((unsigned char*)&d_data[NO])+1)
#define D_LB_ARRAY(NO)   (((unsigned char*)&d_data[NO]))
#define D_ARRAY(NO)     (d_data[NO])
#define PTRD_ARRAY(NO)    (&d_data[NO])
short d_data[3]; // 

#define   _DATAUPPER_  (2) 

#define T0000 	 (0x01 << (0 % 16) ) 
#define TN0000 	 ( t_count[0] / 100000 ) 
#define T0001 	 (0x01 << (1 % 16) ) 
#define TN0001 	 ( t_count[1] / 100000 ) 
#define T0002 	 (0x01 << (2 % 16) ) 
#define TN0002 	 ( t_count[2] / 100000 ) 
#define T0200 	 (0x01 << (200 % 16) ) 
#define TN0200 	 ( t_count[200] / 100000 ) 
#define T0201 	 (0x01 << (201 % 16) ) 
#define TN0201 	 ( t_count[201] / 100000 ) 

#define GET_T(DEVICE,NO) 	 (t_relay[ NO / 16 ] & DEVICE)
#define SET_T_ON(DEVICE,NO) 	 t_relay[ NO / 16 ] = t_relay[ NO / 16 ] | DEVICE
#define SET_T_OFF(DEVICE,NO) 	 t_relay[ NO / 16 ] = t_relay[ NO / 16 ] & ~DEVICE


unsigned short t_relay[13]; // 
unsigned long t_count[202]; // 

#define   _TIMERUPPER_  (201) 

#define C0000 	 (0x01 << (0 % 16) ) 
#define CN0000 	 ( c_count[0] ) 
#define C0001 	 (0x01 << (1 % 16) ) 
#define CN0001 	 ( c_count[1] ) 
#define C0002 	 (0x01 << (2 % 16) ) 
#define CN0002 	 ( c_count[2] ) 
#define GET_C(DEVICE,NO) 	 (c_relay[ NO / 16 ] & DEVICE)
#define SET_C_ON(DEVICE,NO) 	 c_relay[ NO / 16 ] = c_relay[ NO / 16 ] | DEVICE
#define SET_C_OFF(DEVICE,NO) 	 c_relay[ NO / 16 ] = c_relay[ NO / 16 ] & ~DEVICE

unsigned short c_relay[1]; // 
unsigned long c_count[3]; // 

#define   _COUNTERUPPER_  (2) 

// 使用する変数やマクロの宣言部

#define M9010   (0x01 << 0)   //  Errorフラグ
#define M9012   (0x01 << 1)   //  Carryフラグ
#define M9013   (0x01 << 2)   //  0(ゼロ)フラグ
#define M9030   (0x01 << 3)   // ０．１秒クロックパルス
#define M9031   (0x01 << 4)   // ０．２秒クロックパルス
#define M9032   (0x01 << 5)  // １．０秒クロックパルス
#define M9033   (0x01 << 6)  // ２．０秒クロックパルス
#define M9034   (0x01 << 7)  // ３０．０秒クロックパルス
#define M9038   (0x01 << 8)  // １－Ｓｃａｎ　On
#define M9036   (0x01 << 9)  // 常時　On　リレー
#define M9037   (0x01 << 10)  // 常時　ＯＦＦ　リレー
#define M9035   (0x01 << 11)  // 0.01秒　クロックパルス
#define M9003   (0x01 << 12) // 継続命令フラグ
#define M9039   (0x01 << 13)  // 0.005秒　クロックパルス
#define M9040   (0x01 << 16)  // シリアル通信受信完了フラグ
#define M9041   (0x01 << 17)  // シリアル通信受信エラーフラグ
#define M9053   (0x01 << 15)  // 割込みタイマの条件フラグ変数
#define GET_E(DEVICE,NO)    (tokreg & DEVICE)
#define SET_E_ON(DEVICE,NO)  tokreg = tokreg | DEVICE
#define SET_E_OFF(DEVICE,NO)  tokreg = tokreg & ~DEVICE
unsigned long  tokreg; // 特殊リレー用変数

#define	UTRG0000	(0x01 << (0 % 16) )
#define	UTRG0001	(0x01 << (1 % 16) )
#define	UTRG0002	(0x01 << (2 % 16) )
#define	UTRG0003	(0x01 << (3 % 16) )
#define	UTRG0004	(0x01 << (4 % 16) )
#define	UTRG0005	(0x01 << (5 % 16) )
#define	UTRG0006	(0x01 << (6 % 16) )
#define	UTRG0007	(0x01 << (7 % 16) )
#define	UTRG0008	(0x01 << (8 % 16) )
#define	UTRG0009	(0x01 << (9 % 16) )
#define	UTRG0010	(0x01 << (10 % 16) )
#define	UTRG0011	(0x01 << (11 % 16) )
#define	UTRG0012	(0x01 << (12 % 16) )
#define	UTRG0013	(0x01 << (13 % 16) )
#define	UTRG0014	(0x01 << (14 % 16) )
#define	UTRG0015	(0x01 << (15 % 16) )
#define GET_UTRG(DEVICE,NO)  (u_plsg[NO/16] & DEVICE)  
#define SET_UTRG_ON(DEVICE,NO)   u_plsg[NO/16] = u_plsg[NO/16] | DEVICE
#define SET_UTRG_OFF(DEVICE,NO)  u_plsg[NO/16] = u_plsg[NO/16] & ~DEVICE
unsigned short u_plsg[2]; // 立ち上りパルス用のリレーフラグ
unsigned long starttime;
unsigned long lasttime;
unsigned long spantime;
unsigned long maxspantime;
unsigned long minspantime;
unsigned long lasttime_ms;
unsigned long spantime_ms;

unsigned long systemtime;
unsigned long systemtimes;
unsigned long systemtime10ms;
unsigned long in_data ;  // 入力Ｘの保持変数（３２点数分）
unsigned long out_data ;  // 出力Ｙの保持変数（３２点数分）

unsigned int  ldlg; // ブロック用変数
unsigned int  aax; // 回路の状態保持変数
unsigned int  iix;  // ＭＣの状態保持用変数
unsigned int  q;
unsigned int  trlg; // ＭＰＳ／ＭＲＤ／ＭＰＰ
byte        mcflg;  // ＭＣのフラグ
int			flag;


int bcdbin(int a);
int bcd8bin(int a);
int binbcd(int a);
int bin8bcd(int a);
uint8_t rvData[256]; //  
uint8_t txData[256]; // 応答で使用する文字列
uint16_t inposrc = 0;
uint16_t inpostx = 0; 
// 連枝からのモニタのコマンド受信解析応答データ生成関数
	int8_t AnalyzePacket(uint8_t *pdata, uint8_t datalen) {		
		uint16_t dataLength;  // 受信コマンド中のデータ長　STX + (8*) + B + **** * ETX 
		char dvc;           // DeviceChar		
		uint8_t devNo;      // DeviceNumber		
		if (pdata[0] == 0x2) {   // 開始データ（0x02 STX)		
			dataLength = pdata[1] & 0x7F;		
			if (pdata[dataLength + 3] == 0x3) {  // 終了データ(0x03 ETX)		
			}		
			else {  // 終了データの位置に0x03が無い		
				return -1;		
			}		
		}		
		else { // 開始データでない		
			return -1;		
		}		
		switch (pdata[2]) {		
		case 0xDB:  // 問合せ開始コマンド		
			txData[0] = 0x02; // STX		
			txData[1] = 0x80; // (80 + Len)		
			txData[2] = 0x0A; // AckResponse		
			txData[3] = 0x03; // ETX		
			txData[4] = 0x00; // 		
			return 4;		
			break;		
		case 0x0A:  // 返答可能コマンド		
			return 0;		
			break;		
		case 0x0B:  // ビット単位の要求コマンド		
			txData[0] = 0x02; // STX		
			txData[1] = 0x81; // (80 + Len)		
			txData[2] = 0x0B; // BitDataResponse		
			txData[3] = 0x00; // BitData		
			txData[4] = 0x03; // ETX		
			txData[5] = 0x00; // 		
			break;		
		case 0x0D:  // ワード単位の要求コマンド		
			txData[0] = 0x02; // STX		
			txData[1] = 0x80; // (80 + Len)		
			txData[2] = 0x0D; // WordDataRespose		
			break;		
		default:  // 定義されたデータでない場合		
			return -1;		
		}		
		int respos = 0;		
		if (pdata[2] == 0x0D) {		
        for (int i = 3; i<dataLength + 3; i += 2) {		
				if (pdata[i + 1] == 0xff) { // タイマーやカウンタの場合、２つ目は0xff番地となる		
					continue;		
				}		
				txData[3 + 2 * respos + 1] = 0; // 送信データをクリアしておく  		
				txData[3 + 2 * respos] = 0; // 送信データをクリアしておく  
				switch (pdata[i]) {		
				case 0x8D:  // "Word D Device"		
					dvc = 'D';		
					devNo = (pdata[i + 1]) >> 1;		
#ifdef _DATAUPPER_		
					if (devNo <= _DATAUPPER_) {        // デバイス番号が存在するとき              		
							txData[3 + respos] = d_data[devNo] & 0xff;    
							txData[3 + respos + 1] = (d_data[devNo] >> 8) & 0xff;		
					} else {                // デバイス番号が存在しない時		
							txData[3 + respos + 1] = 0;		
							txData[3 + respos] = 0;		
					}		
#endif		
					pdata[i+2+1] = 0xff;
					respos+=2;		
					break;		
				case 0x84:  // "Word T Device"		
					dvc = 'T';		
					devNo = (pdata[i + 1] & 0x7f);		
#ifdef _TIMERUPPER_		
					if (devNo <= _TIMERUPPER_) { // デバイス番号が存在するとき		
					    int  tmp = t_count[devNo] / 100000;		
						txData[3 + respos] = tmp & 0xff;		
						txData[3 + respos+1] = (tmp >> 8) & 0xff;		
					}		
					else {    // デバイス番号が存在しない時		
						txData[3 + respos] = 0;		
						txData[3 + respos + 1] = 0;		
					}		
#endif		
					respos+=2;		
					break;		
				case 0x85:  // "Word C Device"		
					dvc = 'C';		
					devNo = (pdata[i + 1] & 0x7f);		
#ifdef _COUNTERUPPER_		
					if (devNo <= _COUNTERUPPER_) {		
						txData[3 + respos] = c_count[devNo] & 0xff;		
						txData[3 + respos + 1] = (c_count[devNo] >> 8) & 0xff;		
					}		
					else {		
						txData[3 + respos] = 0;		
						txData[3 + respos + 1] = 0;		
					}		
#endif		
					respos+=2;		
					break;		
               case 0xC1:   // "Byte Order Y Device" 
                   dvc = 'Y';    
                   devNo = (pdata[i + 1] & 0x7f);   
#ifdef _OUTYUPPER_                
                   if (_OUTYUPPER_  >= devNo * 8){ 
                     devNo = devNo >> 1;  
                     txData[3 + respos] = 0;  
                     txData[3 + respos + 1] = 0;    
                   }else{
                     txData[3 +  respos] = 0;   
                     txData[3 +  respos + 1] = 0;   
                   }
#endif               
                   pdata[i+3]=0xff;
                   respos+=2;
                   break;
               
               
				case 0xC2:  // "Byte Order M Device"		
					dvc = 'M';		
					devNo = (pdata[i + 1] & 0x7f);		
#ifdef _MUPPER_		
					if (_MUPPER_  >= devNo * 8){		
					    if(devNo % 2==0){		
						    devNo = devNo >> 1;		
						  txData[3 + respos ] = m_relay[devNo] & 0xFF; 		
						  txData[3 + respos + 1] = (m_relay[devNo]>>0x08) & 0xFF;  		
					    }else{
						    devNo = devNo >> 1;		
					      txData[3 + respos ] = (m_relay[devNo]>>0x08) & 0xFF;
					      txData[3 + respos + 1] = m_relay[devNo+1] & 0xFF;       
					    }
					}else{
					  txData[3 + respos] = 0;   
					  txData[3 + respos + 1] = 0;    
					}
					pdata[i+3]=0xff;
#endif		
					respos+=2;		
					break;		
				default:  // "Unknown Device"
					dvc = '?';		
					devNo = (pdata[i + 1] & 0x7f);
					txData[3 + respos] = 0;		
					txData[3 + respos + 1] = 0;		
					respos+=2;		
					break;		
				}		
			}
			txData[1] = 0x80 | (respos); // デバイス数 * 2 がデータサイズ		
			txData[3 + respos] = 0x03;     // ETX		
			txData[3 + respos + 1] = 0x00;     // 終端文字		
			return (3 + respos + 1); // STX DataLen D * * * * ETX		
		}		
		else if (pdata[2] == 0x0B) {		
			for (int i = 3; i<dataLength + 3; i += 2) {		
				switch (pdata[i]) {		
				case 0x0: // "Bit X Device"		
					devNo = bcdbin(pdata[i + 1] & 0x7f);     // BCD->BIN（16進数表記   ）   		
					dvc = 'X';		
                    txData[3] = txData[3] << 1;   
#ifdef _INXUPPER_        // Xが存在するとき		
					for (int n = 0; n < sizeof(in_no); n++) {		
						if (devNo == in_no[n]) {		
							if (in_data & (0x01 << n)) {		
								txData[3] |= 0x01;		
							}		
						}		
					}		
#endif		
					break;		
				case 0x10:  // "Bit Y Device"		
					devNo = bcdbin(pdata[i + 1] & 0x7f);      // BCD->BIN（16進数表記   ）   		
					dvc = 'Y';		
                    txData[3] = txData[3] << 1;   
#ifdef _OUTYUPPER_  // Yが存在するとき		
					for (int n = 0; n < sizeof(out_no); n++) {		
						if (devNo == out_no[n]) {		
							if (out_data & (0x01 << n)) {		
								txData[3] |= 0x01;		
							}		
						}		
					}		
#endif		
					break;		
				case 0x40:  // "Bit T Device"		
					devNo = pdata[i + 1] & 0x7f;  // そのまま（10進数表記   ）   		
					dvc = 'T';		
                    txData[3] = txData[3] << 1;   
#ifdef _TIMERUPPER_  // Tが存在するとき		
					if (devNo <= _TIMERUPPER_) {		
						if (t_relay[devNo / 16] & (0x01 << (devNo % 16))) {		
							txData[3] |= 0x01;		
						}		
					}		
#endif		
					break;		
				case 0x50:  // "Bit C Device"		
					devNo = pdata[i + 1] & 0x7f;     // そのまま（10進数表記   ）		
					dvc = 'C';		
                    txData[3] = txData[3] << 1;   
#ifdef _COUNTERUPPER_  // Cが存在するとき		
					if (devNo <= _COUNTERUPPER_) {		
						if (c_relay[devNo / 16] & (0x01 << (devNo % 16))) {		
							txData[3] |= 0x01;		
						}		
					}		
#endif		
					break;		
				case 0x20:  // "Bit M Device"		
					devNo = pdata[i + 1] & 0x7f;  // そのまま（10進数表記   ）		
					dvc = 'M';		
                    txData[3] = txData[3] << 1;   
#ifdef _MUPPER_ // Mが存在するとき		
					if (devNo <= _MUPPER_) {		
						if (m_relay[devNo / 16] & (0x01 << (devNo % 16))) {		
							txData[3] |= 0x01;		
						}		
					}		
#endif		
					break;		
				case 0x70:  // "特殊リレー"		
                    unsigned long tmpdata;
					devNo = pdata[i + 1] & 0x7f;  // そのまま（10進数表記   ）		
					dvc = 'S';		
                    txData[3] = txData[3] << 1;   
					if (devNo == 5) {		// 常時ＯＮリレー
						tmpdata = GET_E(M9036,9036);		
					} else if(devNo == 	6){	// 常時OFFリレー	
						tmpdata = GET_E(M9037,9037);		
					} else if(devNo == 	7){	// 1scan Onリレー	
						tmpdata = GET_E(M9038,9038);		
					} else if(devNo == 	10){	// 1秒クロックパルス	
						tmpdata = GET_E(M9032,9032);		
					} else if(devNo == 	9){	// 0.2秒クロックパルス	
						tmpdata = GET_E(M9031,9031);		
					} else if(devNo == 	8){	// 0.1秒クロックパルス	
						tmpdata = GET_E(M9030,9030);		
					} else if(devNo == 	15){	// Zero	
						tmpdata = 0;		
					} else if(devNo == 	14){	// Carry	
						tmpdata = 0;		
					} else if(devNo == 	1){	// Error	
						tmpdata = 0;		
					} else if(devNo == 	11){	// 2.0秒クロックパルス	
						tmpdata =  GET_E(M9033,9033);		
					} else if(devNo == 	12){	// 30.0秒クロックパルス	
						tmpdata =  GET_E(M9034,9034);		
					} else if(devNo == 	13){	// 0.01秒クロックパルス	
						tmpdata =  GET_E(M9035,9035);		
					} else if(devNo == 	16){	// 0.005秒クロックパルス	
						tmpdata =  GET_E(M9039,9039);		
					} else {
                        tmpdata = 0;
                    }		
					if(tmpdata!=0){
                        txData[3] |= 0x01;		
					}		
					
					break;		
				default:  // "Unknown Device"		
					dvc = '?';		
                    txData[3] = txData[3] << 1;   
					break;		
				}		
			}		
			txData[3] |= 0x80;		
			return 5;   //  STX  DataLen  B  *  ETX		
		}		
		return 0;		
	}		

hw_timer_t * htimer = NULL;
volatile SemaphoreHandle_t timerSemaphore;
portMUX_TYPE timerMux = portMUX_INITIALIZER_UNLOCKED;

volatile int32_t onCounter=0;
volatile int32_t offCounter=0;

void IRAM_ATTR onTimer(){
  portENTER_CRITICAL_ISR(&timerMux);

    if( GET_E(M9053,9053) ) { 
        onCounter--;
    }else{
        offCounter--;
    }

  portEXIT_CRITICAL_ISR(&timerMux);

  xSemaphoreGiveFromISR(timerSemaphore,NULL);
}

void timerStart(){
  if (htimer==NULL){
    htimer = timerBegin(3,80,true);	// プリスケーラを80にセット1us単位

    timerAttachInterrupt(htimer,&onTimer,true);
    timerAlarmWrite(htimer,1000,true);	// 1ms(1us * 1000) 単位で割込み処理

    portENTER_CRITICAL(&timerMux);
    portEXIT_CRITICAL(&timerMux);

    timerAlarmEnable(htimer);
  }
}
void timerStop(){
  if(htimer!=NULL){
    timerEnd(htimer);
    htimer = NULL;  
  }
}
// MCP23008 初期化処理 
void initMCP(byte address, byte direct) {
	 Wire.begin();

	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x00);    // 入出力IO方向レジスタの番地
	 Wire.write(direct);	// 入出力IO方向レジスタの値
	 Wire.write(direct); // 論理の反転レジスタの値
	 Wire.endTransmission();

	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x06);	// プルアップのレジスタの番地
	 Wire.write(direct);	// プルアップのレジスタ
	 Wire.endTransmission();

	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x09);
	 Wire.write(direct); 	// PORTのIOレジスタ
	 Wire.write(direct);	// LATCHのレジスタ 
	 Wire.endTransmission();
}


// MCP23017 初期化処理
void initMCP(byte address, unsigned short direct) {
	 Wire.begin();

	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x00);	// 入出力IO方向レジスタの番地
	 Wire.write(direct & 0xff);	// 入出力IO方向レジスタの値 A
	 Wire.write((direct>>8) & 0xff);	//  入出力IO方向レジスタの値 B
	 Wire.write(direct & 0xff); // 論理の反転レジスタの値 A
	 Wire.write((direct>>8) & 0xff); // 論理の反転レジスタの値 B
	 Wire.endTransmission();

	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x0C);	// 
	 Wire.write(direct & 0xff);	// プルアップのレジスタ A
	 Wire.write((direct>>8) & 0xff); // プルアップのレジスタ B
	 Wire.endTransmission();

	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x12);
	 Wire.write(direct & 0xff);	// PORTAのIOレジスタ
	 Wire.write((direct>>8) & 0xff);// PORTBのIOレジスタ
	 Wire.write(direct & 0xff);	// LATCHAのレジスタ
	 Wire.write((direct>>8) & 0xff);	// LATCHBのレジスタ
	 Wire.endTransmission();
}

byte readMCP(byte address,byte direct) {
	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x09);
	 Wire.endTransmission();
	 Wire.requestFrom(0x20 | address,1);
	 byte recvdata = Wire.read();
	 Wire.endTransmission();
	 recvdata = recvdata & direct;
	 return recvdata;
}

unsigned short readMCP(byte address,unsigned short direct) {
	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x12);
	 Wire.endTransmission();
	 Wire.requestFrom(0x20 | address,2);
	 unsigned short recvdata = Wire.read();
	 recvdata = recvdata | ((unsigned short)Wire.read() << 8);
	 Wire.endTransmission();
	 recvdata = recvdata & direct;
	 return recvdata;
}

void writeMCP(byte address,byte direct,byte writedata) {
	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x09);
	 Wire.write(writedata);
	 Wire.endTransmission();
}

void writeMCP(byte address,unsigned short direct,unsigned short writedata) {
	 Wire.begin();
	 Wire.beginTransmission(0x20 | address);
	 Wire.write(0x12);
	 Wire.write(writedata & 0xff);
	 Wire.write((writedata>>8) & 0xff);
	 Wire.write(writedata & 0xff);
	 Wire.write((writedata>>8) & 0xff);
	 Wire.endTransmission();
}

void tftUpdate(void *args);
// TFTの初期化関数
void tftInit() { 
	 M5.Lcd.fillScreen(TFT_BLACK); // 
	 M5.Lcd.setTextDatum(MC_DATUM); 
	 D9002 = 1; 
   xTaskCreatePinnedToCore(tftUpdate,"tftupdate", 4096, NULL, 30, NULL, 1);
}
// TFTのページ変更関数
void tftPageChange(int no) { 
	 if ( (no <= PageMaxCnt) && (no >= 0) ) {
	 	 D9002 = no; 
	 }
}
// TFTのページ番号取得関数
int tftgetPageNo() { 
	  return D9002; 
}

// loop関数の中でTFTの表示更新関数  
void tftUpdate(void *args){
	 delay(10);
	 while(1){
	 	 delay(1);
	 	 M5.Lcd.setTextDatum(MC_DATUM); 
	// 前回のページ番号と今回のページ番号が違う場合は、画面をクリアして描画しなおす
	 if( (lastPageNo!=D9002) && (D9002 <= PageMaxCnt)){
	 	 M5.Lcd.setTextSize(3); //
	 	 switch (D9002) { 
	 	 case 0:
	 	 	 M5.Lcd.clear(TFT_BLACK); //
	 	 	 M5.Lcd.drawString("D9002=0",70,200);
	 	 	 break;
	 	 case 1:
	 	 	 M5.Lcd.clear(TFT_BLACK); //
	 	 	 M5.Lcd.drawString("D9002=1",70,200);
	 	 	 break;
	 	 case 2:
	 	 	 M5.Lcd.clear(TFT_BLACK); //
	 	 	 M5.Lcd.drawString("D9002=2",70,200);
	 	 	 
	 	 	 break;
	 	 case 3:
	 	 	 M5.Lcd.clear(TFT_BLACK); //
	 	 	 M5.Lcd.drawString("D9002=3",70,200);
	 	 	 
	 	 	 break;
	 	 case 4:
	 	 	 M5.Lcd.clear(TFT_BLACK); //
	 	 	 M5.Lcd.drawString("D9002=4",70,200);
	 	 	 
	 	 	 break;
	 	 case 5:
	 	 	 M5.Lcd.clear(TFT_BLACK); //
	 	 	 M5.Lcd.drawString("D9002=5",70,200);
	 	 	 
	 	 	 break;
	 	 }
	 	 M5.Lcd.setTextSize(2); //
	 	 M5.Lcd.setTextColor(TFT_BLACK,TFT_GREEN);
	 	 M5.Lcd.fillRect(12,12,46,46,TFT_GREEN);
	 	 M5.Lcd.drawString("P0",35,35);
	 	 M5.Lcd.fillRect(62,12,46,46,TFT_GREEN);
	 	 M5.Lcd.drawString("P1",85,35);
	 	 M5.Lcd.fillRect(112,12,46,46,TFT_GREEN);
	 	 M5.Lcd.drawString("P2",135,35);
	 	 M5.Lcd.fillRect(162,12,46,46,TFT_GREEN);
	 	 M5.Lcd.drawString("P3",185,35);
	 	 M5.Lcd.fillRect(212,12,46,46,TFT_GREEN);
	 	 M5.Lcd.setCursor(235,35); //
	 	 M5.Lcd.drawString("P4",235,35);
	 	 M5.Lcd.fillRect(262,12,46,46,TFT_GREEN);
	 	 M5.Lcd.drawString("P5",285,35);
	 	 
	 	 delay(1);
	 	 lastPageNo = D9002;
	 	 lastmenupos = -1;
	 } else {
	 	      char msg[30];
	 	 if (lastmenupos != D9005){
	 	 	 M5.Lcd.setTextSize(3); //
	 	 	 M5.Lcd.setTextColor(TFT_WHITE,TFT_BLACK);
	 	 	 sprintf(msg,"D9005=%d",D9005);
	 	 	 M5.Lcd.drawString(msg,70,225);
	 	 delay(1);
	 	 	 if(lastmenupos >= 0){
	 	 	 	 switch (lastmenupos){
	 	 	 	 	 case 0:
	 	 	 	 	 	 M5.Lcd.drawRect(10,10,50,50,TFT_BLACK);
	 	 	 	 	 	 break;
	 	 	 	 	 case 1:
	 	 	 	 	 	 M5.Lcd.drawRect(60,10,50,50,TFT_BLACK);
	 	 	 	 	 	 break;
	 	 	 	 	 case 2:
	 	 	 	 	 	 M5.Lcd.drawRect(110,10,50,50,TFT_BLACK);
	 	 	 	 	 	 break;
	 	 	 	 	 case 3:
	 	 	 	 	 	 M5.Lcd.drawRect(160,10,50,50,TFT_BLACK);
	 	 	 	 	 	 break;
	 	 	 	 	 case 4:
	 	 	 	 	 	 M5.Lcd.drawRect(210,10,50,50,TFT_BLACK);
	 	 	 	 	 	 break;
	 	 	 	 	 case 5:
	 	 	 	 	 	 M5.Lcd.drawRect(260,10,50,50,TFT_BLACK);  
	 	 	 	 	 	 break;
	 	 	 	 } 
	 	 	 delay(1);
	 	 	 } 
	 	 	 switch (D9005) {
	 	 	 	 case 0:
	 	 	 	 	 M5.Lcd.drawRect(10,10,50,50,TFT_YELLOW);;
	 	 	 	 	 break;
	 	 	 	 case 1:
	 	 	 	 	 M5.Lcd.drawRect(60,10,50,50,TFT_YELLOW);;
	 	 	 	 	 break;
	 	 	 	 case 2:
	 	 	 	 	 M5.Lcd.drawRect(110,10,50,50,TFT_YELLOW);;
	 	 	 	 	 break;
	 	 	 	 case 3:
	 	 	 	 	 M5.Lcd.drawRect(160,10,50,50,TFT_YELLOW);;
	 	 	 	 	 break;
	 	 	 	 case 4:
	 	 	 	 	 M5.Lcd.drawRect(210,10,50,50,TFT_YELLOW);;
	 	 	 	 	 break;
	 	 	 	 case 5:
	 	 	 	 	 M5.Lcd.drawRect(260,10,50,50,TFT_YELLOW);;
	 	 	 	 	 break;
	 	 	 }
	 	 	 delay(1);
	 	 	 lastmenupos = D9005;
	 	 }
	 }
	 }
}
// standard function
	
void input_refresh() {
	 	 for (byte i=0; i<sizeof(in_no); i++) { 
	 	 	 if (digitalRead(in_no[i])==HIGH) { 
	 	 	 	 in_data = in_data & ~(0x01 << i);
	 	 	 } else { 
	 	 	 	 in_data = in_data | (0x01 << i);
	 	 	 }
	 	 }
} 
	 
	
void mcp_refresh() {
}
void output_refresh() {
	 for (byte i=0; i<sizeof( out_no ); i++) { 
	 	 if ( out_data & (0x01 << i) ) {
	 	 	 digitalWrite( out_no[i], HIGH );
	 	 } else {
	 	 	 digitalWrite( out_no[i] , LOW );
	 	 }
	 }
}
// リンクリフレッシュ関数宣言部(将来のために用意)
void link_refresh()
{
	 
}
// タイマーの時間経過関数宣言部
void time_refresh() {
	 unsigned long nowtime; 
	 nowtime = micros(); 
	 spantime = nowtime - lasttime;
	 lasttime = nowtime;
	 nowtime = millis(); // 電源ＯＮ後の経過時間をmsで取得する
	 if (spantime>maxspantime) maxspantime=spantime;
	 if (spantime<minspantime) minspantime=spantime;
	 spantime_ms = nowtime - lasttime_ms;
	 lasttime_ms = nowtime;
	 
	 
} 
// special_relay refresh 
void special_refresh() {
	 static unsigned long c30s = 0;
// 500ms単位の動作（０．５秒のリレーを作る部分）
	 if ( systemtimes + spantime >= 500000) {
	 	 systemtimes = systemtimes + spantime - 500000;
	 	 if ( GET_E(M9032,0) ){
	 	 	 SET_E_OFF(M9032,0);
	 	 	 if (GET_E(M9033,0)) {
	 	 	 	 SET_E_OFF(M9033,0);
	 	 	 } else {
	 	 	 	 SET_E_ON(M9033,0);
	 	 	 } 
	 	 } else {
	 	 	 SET_E_ON(M9032,0);
	 	 } 
	 	 c30s++; 
	 	 if (c30s>=30){ 
	 	 	 c30s=0; 
	 	 	 if(GET_E(M9034,0)){ 
	 	 	 	 SET_E_OFF(M9034,0); 
	 	 	 } else { 
	 	 	 	 SET_E_ON(M9034,0); 
	 	 	 } 
	 	 } 
	 	  
	 } else { 
	 	 systemtimes += spantime;
	 }

//' 50ms単位の動作（０．１秒のリレーを作る部分）
	 if ( systemtime + spantime >= 50000) { 
	 	 systemtime = systemtime + spantime - 50000;
	 	 if ( GET_E(M9030,0) ){
	 	 	 SET_E_OFF(M9030,0);
	 	 	 if (GET_E(M9031,0)) {
	 	 	 	 SET_E_OFF(M9031,0);
	 	 	 } else { 
	 	 	 	 SET_E_ON(M9031,0);
	 	 	 } 
	 	 } else {
	 	 	 SET_E_ON(M9030,0);
	 	 }
	 } else {
	 	 systemtime += spantime;
	 }
	 
// 5ms単位の動作（０．０１秒のリレーを作る部分）
	 if ( systemtime10ms + spantime >= 5000) {
	 	 systemtime10ms = systemtime10ms + spantime - 5000;
	 	 if ( GET_E(M9035,0) ){
	 	 	 SET_E_OFF(M9035,0);
	 	 	 if (GET_E(M9039,0)) {
	 	 	 	 SET_E_OFF(M9039,0);
	 	 	 } else {
	 	 	 	 SET_E_ON(M9039,0);
	 	 	 }
	 	 } else {
	 	 	 SET_E_ON(M9035,0);
	 	 }
	 } else {
	 	 systemtime10ms += spantime;
	 }
} 
/////////////// bcd to bin function (4digit)
int bcdbin( int a )
{ 
	 int q ;
	 q = a&0x0f ;
	 q +=((a&0xf0)>>4)*10 ;
	 q +=((a&0xf00)>>8)*100 ;
	 q +=((a&0xf000)>>12)*1000 ;
	 return( q ) ;
}
/////////////// bcd to bin function (8digit)
long bcd8bin( long a )
{ 
	 int q ;
	 q = ( a & 0xf );
	 q +=((a&0xf0)>>4)*10 ;
	 q +=((a&0xf00)>>8)*100 ;
	 q +=((a&0xf000)>>12)*1000 ;
	 q +=((a&0xf0000)>>16)*10000 ;
	 q +=((a&0xf00000)>>20)*100000 ;
	 q +=((a&0xf000000)>>24)*1000000 ;
	 q +=((a&0xf0000000)>>28)*10000000 ;
	 return( q ) ;
}

/////////////// bin to bcd function (4digit)
int binbcd(int a)
{ 
	 int q,tmp; 
	 q = ( a % 10);   // 1
	 tmp = a / 10;
	 q |= ( (tmp % 10) ) << 4; // 10  
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 8; // 100
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 12; // 1000
	 return (q);
} 

/////////////// bin to bcd function (8digit)
long bin8bcd(long a)
{
	 int q,tmp; 
	 q = ( a % 10);   // 1
	 tmp = a / 10;
	 q |= ( (tmp % 10) ) << 4; // 10  
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 8; // 100
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 12; // 1000
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 16; // 10000 
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 20; // 100000 
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 24; // 1000000 
	 tmp = tmp / 10;
	 q |= ( (tmp % 10) ) << 28; // 10000000 
	 return (q); 
}

