//   Standard File

////////////////////////////////////////////////////
// RenriVer8.70  DllLibrary Arduino  0.01         //
// c source builder by  SEQ_CBuilder V            //
// TargetCPU = ESP32(WROOM32)                     //
// make      andor.ino File  2019/02/11 17:57     //
////////////////////////////////////////////////////
// device_list //
 // X0021 	X0023 	X0034 	X0035 	// XDevice = 4
 // Y0018 	Y0019 	// YDevice = 2 
 // // MDevice = 0  
 // // DDevice = 0  
 // // TDevice = 0  
 // // CDevice = 0  
 // // LDevice = 0  
 // // rDevice = 0  
 // // device_list //

#include "andor.h";


void setup(){
	 byte		tmp;

	 int		count = 0;
	 for (byte i=0; i<sizeof(in_no); i++) {
	 	 pinMode(in_no[i],INPUT);
	 }
	 for (byte i=0; i<sizeof(out_no); i++) {
	 	 pinMode(out_no[i],OUTPUT);
	 } 
	 
	 lasttime = micros(); // 時間の取得（ us単位 ）
	 lasttime_ms = millis(); // 時間の取得（ ms単位 )
	 q = 0x01;
	 SET_E_ON(M9038,0);     //  1スキャンＯＮリレーの生成
	 SET_E_ON(M9036,0);     //  常時ＯＮリレーの生成
	 SET_E_OFF(M9037,0);    // 常時ＯＦＦリレーの生成
}

////////////////////////////// Loop 開始(スキャンプログラム) //////////////////////////////
void loop(){			// 

	 int tmp;				// 
	 time_refresh();		// 時間の更新処理
	 link_refresh();		//	リンクリフレッシュ処理
	 special_refresh();	// 特殊リレーの更新処理
	 output_refresh();	// 出力更新処理
	 input_refresh();		// 入力更新処理
	 ldlg = 0x0; //  ブロック用変数;
	 aax = 0x0;  // 回路の状態保持変数;
	 trlg = 0x0; // ＭＰＳ／ＭＲＤ／ＭＰＰ;
	 iix = 0x01; // ＭＣ用変数の初期化;
	 ;
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0021,21);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// AND(03) 
	 flag = GET_X(X0023,23);
	 if ( ! flag ){ //
	 	 aax &= ~0x01; //
	 }//
//
// OUTR(0F) 
	 if (aax & iix) { 
	 	 SET_Y_ON(Y0018,18);
	 } else { 
	 	 SET_Y_OFF(Y0018,18);
	 }
	 
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0034,34);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OR(05) 
	 flag = GET_X(X0035,35);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OUTR(0F) 
	 if (aax & iix) { 
	 	 SET_Y_ON(Y0019,19);
	 } else { 
	 	 SET_Y_OFF(Y0019,19);
	 }
	 
// END(10) 
	 output_refresh();	// 出力更新処理
	// Serial.println();
	 SET_E_OFF(M9038,0);

}
////////////////////////////// Loop 終了 //////////////////////////////
