//   Standard File

////////////////////////////////////////////////////
// RenriVer8.70  DllLibrary Arduino  0.01         //
// c source builder by  SEQ_CBuilder V            //
// TargetCPU = ESP32(WROOM32)                     //
// make        cnt.h File  2019/02/11 18:07       //
////////////////////////////////////////////////////
unsigned  char sysParam;
#define X0021 	 (0x01 << 0) 
#define X0023 	 (0x01 << 1) 
#define X0034 	 (0x01 << 2) 
#define X0035 	 (0x01 << 3) 
byte in_no[] = { 21 , 23 , 34 , 35}; 

#define   GET_X(DEVICE,NO) 	 (in_data & DEVICE)

#define Y0018 	 (0x01 << 0) 
#define Y0019 	 (0x01 << 1) 
#define Y0025 	 (0x01 << 2) 
byte out_no[] = { 18 , 19 , 25}; 

#define GET_Y(DEVICE,NO) 	 (out_data & DEVICE)
#define SET_Y_ON(DEVICE,NO) 	 out_data = out_data | DEVICE
#define SET_Y_OFF(DEVICE,NO) 	 out_data = out_data & ~DEVICE

#define M0010 	 (0x01 << (10 % 16) ) 

#define GET_M(DEVICE,NO) 	 (m_relay[ NO / 16 ] & DEVICE)
#define SET_M_ON(DEVICE,NO) 	 m_relay[ NO / 16 ] = m_relay[ NO / 16 ] | DEVICE
#define SET_M_OFF(DEVICE,NO) 	 m_relay[ NO / 16 ] = m_relay[ NO / 16 ] & ~DEVICE

unsigned short m_relay[1]; // 

#define T0010 	 (0x01 << (10 % 16) ) 
#define TN0010 	 ( t_count[10] / 100000 ) 
#define T0011 	 (0x01 << (11 % 16) ) 
#define TN0011 	 ( t_count[11] / 100000 ) 

#define GET_T(DEVICE,NO) 	 (t_relay[ NO / 16 ] & DEVICE)
#define SET_T_ON(DEVICE,NO) 	 t_relay[ NO / 16 ] = t_relay[ NO / 16 ] | DEVICE
#define SET_T_OFF(DEVICE,NO) 	 t_relay[ NO / 16 ] = t_relay[ NO / 16 ] & ~DEVICE


unsigned short t_relay[1]; // 
unsigned long t_count[12]; // 

#define C0010 	 (0x01 << (10 % 16) ) 
#define CN0010 	 ( c_count[10] ) 
#define GET_C(DEVICE,NO) 	 (c_relay[ NO / 16 ] & DEVICE)
#define SET_C_ON(DEVICE,NO) 	 c_relay[ NO / 16 ] = c_relay[ NO / 16 ] | DEVICE
#define SET_C_OFF(DEVICE,NO) 	 c_relay[ NO / 16 ] = c_relay[ NO / 16 ] & ~DEVICE

unsigned short c_relay[1]; // 
unsigned long c_count[11]; // 

// 使用する変数やマクロの宣言部

#define M9010   (0x01 << 0)   //  Errorフラグ
#define M9012   (0x01 << 1)   //  Carryフラグ
#define M9013   (0x01 << 2)   //  0(ゼロ)フラグ
#define M9030   (0x01 << 3)   // ０．１秒クロックパルス
#define M9031   (0x01 << 4)   // ０．２秒クロックパルス
#define M9032   (0x01 << 5)  // １．０秒クロックパルス
#define M9033   (0x01 << 6)  // ２．０秒クロックパルス
#define M9034   (0x01 << 7)  // ３０．０秒クロックパルス
#define M9038   (0x01 << 8)  // １－Ｓｃａｎ　On
#define M9036   (0x01 << 9)  // 常時　On　リレー
#define M9037   (0x01 << 10)  // 常時　ＯＦＦ　リレー
#define M9035   (0x01 << 11)  // 0.01秒　クロックパルス
#define M9003   (0x01 << 12) // 継続命令フラグ
#define M9039   (0x01 << 13)  // 0.005秒　クロックパルス
#define GET_E(DEVICE,NO)    (tokreg & DEVICE)
#define SET_E_ON(DEVICE,NO)  tokreg = tokreg | DEVICE
#define SET_E_OFF(DEVICE,NO)  tokreg = tokreg & ~DEVICE
unsigned long  tokreg; // 特殊リレー用変数

#define	UTRG0000	(0x01 << (0 % 16) )
#define	UTRG0001	(0x01 << (1 % 16) )
#define	UTRG0002	(0x01 << (2 % 16) )
#define GET_UTRG(DEVICE,NO)  (u_plsg[NO/16] & DEVICE)  
#define SET_UTRG_ON(DEVICE,NO)   u_plsg[NO/16] = u_plsg[NO/16] | DEVICE
#define SET_UTRG_OFF(DEVICE,NO)  u_plsg[NO/16] = u_plsg[NO/16] & ~DEVICE
unsigned short u_plsg[1]; // 立ち上りパルス用のリレーフラグ
unsigned long starttime;
unsigned long lasttime;
unsigned long spantime;
unsigned long maxspantime;
unsigned long minspantime;
unsigned long lasttime_ms;
unsigned long spantime_ms;

unsigned long systemtime;
unsigned long systemtimes;
unsigned long systemtime10ms;
unsigned long in_data ;  // 入力Ｘの保持変数（３２点数分）
unsigned long out_data ;  // 出力Ｙの保持変数（３２点数分）

unsigned int  ldlg; // ブロック用変数
unsigned int  aax; // 回路の状態保持変数
unsigned int  iix;  // ＭＣの状態保持用変数
unsigned int  q;
unsigned int  trlg; // ＭＰＳ／ＭＲＤ／ＭＰＰ
byte        mcflg;  // ＭＣのフラグ
int			flag;


// standard function
	
void input_refresh() {
	 	 for (byte i=0; i<sizeof(in_no); i++) { 
	 	 	 if (digitalRead(in_no[i])==HIGH) { 
	 	 	 	 in_data = in_data & ~(0x01 << i);
	 	 	 } else { 
	 	 	 	 in_data = in_data | (0x01 << i);
	 	 	 }
	 	 }
} 
	 
void output_refresh() {
	 for (byte i=0; i<sizeof( out_no ); i++) { 
	 	 if ( out_data & (0x01 << i) ) {
	 	 	 digitalWrite( out_no[i], HIGH );
	 	 } else {
	 	 	 digitalWrite( out_no[i] , LOW );
	 	 }
	 }
}
// リンクリフレッシュ関数宣言部(将来のために用意)
void link_refresh()
{
	 
}
// タイマーの時間経過関数宣言部
void time_refresh() {
	 unsigned long nowtime; 
	 nowtime = micros(); 
	 spantime = nowtime - lasttime;
	 lasttime = nowtime;
	 nowtime = millis(); // 電源ＯＮ後の経過時間をmsで取得する
	 if (spantime>maxspantime) maxspantime=spantime;
	 if (spantime<minspantime) minspantime=spantime;
	 spantime_ms = nowtime - lasttime_ms;
	 lasttime_ms = nowtime;
	 
	 
} 
// special_relay refresh 
void special_refresh() {
// 500ms単位の動作（０．５秒のリレーを作る部分）
	 if ( systemtimes + spantime >= 500000) {
	 	 systemtimes = systemtimes + spantime - 500000;
	 	 if ( GET_E(M9032,0) ){
	 	 	 SET_E_OFF(M9032,0);
	 	 	 if (GET_E(M9033,0)) {
	 	 	 	 SET_E_OFF(M9033,0);
	 	 	 } else {
	 	 	 	 SET_E_ON(M9033,0);
	 	 	 } 
	 	 } else {
	 	 	 SET_E_ON(M9032,0);
	 	 } 
	 } else { 
	 	 systemtimes += spantime;
	 }

//' 50ms単位の動作（０．１秒のリレーを作る部分）
	 if ( systemtime + spantime >= 50000) { 
	 	 systemtime = systemtime + spantime - 50000;
	 	 if ( GET_E(M9030,0) ){
	 	 	 SET_E_OFF(M9030,0);
	 	 	 if (GET_E(M9031,0)) {
	 	 	 	 SET_E_OFF(M9031,0);
	 	 	 } else { 
	 	 	 	 SET_E_ON(M9031,0);
	 	 	 } 
	 	 } else {
	 	 	 SET_E_ON(M9030,0);
	 	 }
	 } else {
	 	 systemtime += spantime;
	 }
	 
// 5ms単位の動作（０．０１秒のリレーを作る部分）
	 if ( systemtime10ms + spantime >= 5000) {
	 	 systemtime10ms = systemtime10ms + spantime - 5000;
	 	 if ( GET_E(M9035,0) ){
	 	 	 SET_E_OFF(M9035,0);
	 	 	 if (GET_E(M9039,0)) {
	 	 	 	 SET_E_OFF(M9039,0);
	 	 	 } else {
	 	 	 	 SET_E_ON(M9039,0);
	 	 	 }
	 	 } else {
	 	 	 SET_E_ON(M9035,0);
	 	 }
	 } else {
	 	 systemtime10ms += spantime;
	 }
} 
/////////////// bcd to bin function (4digit)
int bcdbin( int a )
{ 
	 int q ;
	 q = a&0x0f ;
	 q +=((a&0xf0)>>4)*10 ;
	 q +=((a&0xf00)>>8)*100 ;
	 q +=((a&0xf000)>>12)*1000 ;
	 return( q ) ;
}
/////////////// bcd to bin function (8digit)
int bcd8bin( int a )
{ 
	 int q ;
	 q |=((a&0xf0)>>4)*10 ;
	 q |=((a&0xf00)>>8)*100 ;
	 q |=((a&0xf000)>>12)*1000 ;
	 q |=((a&0xf0000)>>16)*10000 ;
	 q |=((a&0xf00000)>>20)*100000 ;
	 q |=((a&0xf000000)>>24)*1000000 ;
	 q |=((a&0xf0000000)>>28)*10000000 ;
	 return( q ) ;
}

/////////////// bin to bcd function (4digit)
int binbcd(int a)
{ 
	 int q;
	 q = (a );
	 q += ( (a / 10) ) << 4; 
	 q += ( (a / 100) ) << 8; 
	 q += ( (a / 1000) ) << 12;
	 return (q);
} 

/////////////// bin to bcd function (8digit)
int bin8bcd(int a)
{
	 int q; 
	 q = (a ); 
	 q += ( (a / 10) ) << 4; 
	 q += ( (a / 100) ) << 8; 
	 q += ( (a / 1000) ) << 12; 
	 q += ( (a / 10000) ) << 16; 
	 q += ( (a / 100000) ) << 20; 
	 q += ( (a / 1000000) ) << 24; 
	 q += ( (a / 10000000) ) << 28; 
	 return (q); 
}

