//   Professional File

////////////////////////////////////////////////////
// RenriVer8.70  DllLibrary Arduino  0.01         //
// c source builder by  SEQ_CBuilder V            //
// TargetCPU = ESP32(WROOM32)                     //
// make pwm_pulse1.ino File  2019/02/23 20:59     //
////////////////////////////////////////////////////
// device_list //
 // X0023 	X0034 	X0035 	// XDevice = 3
 // // YDevice = 0 
 // // MDevice = 0  
 // D0000 	// DDevice = 1  
 // // TDevice = 0  
 // // CDevice = 0  
 // // LDevice = 0  
 // // rDevice = 0  
 // // device_list //

#include "pwm_pulse1.h";


void setup(){
	 byte		tmp;

	 int		count = 0;
	 for (byte i=0; i<sizeof(in_no); i++) {
	 	 pinMode(in_no[i],INPUT);
	 }
	 D8401 = 50;
	 D8402 = 50;
	 D8403 = 0;
	 D8404 = 18;
	 D8405 = 0;
	 D8406 = 4095;
	 D8407 = 7000;
	 D8408 = 32767;

	 D8411 = 50;
	 D8412 = 50;
	 D8413 = 0;
	 D8414 = 18;
	 D8415 = 0;
	 D8416 = 4095;
	 D8417 = 7000;
	 D8418 = 32767;

	 
	 lasttime = micros(); // 時間の取得（ us単位 ）
	 lasttime_ms = millis(); // 時間の取得（ ms単位 )
	 q = 0x01;
	 SET_E_ON(M9038,0);     //  1スキャンＯＮリレーの生成
	 SET_E_ON(M9036,0);     //  常時ＯＮリレーの生成
	 SET_E_OFF(M9037,0);    // 常時ＯＦＦリレーの生成
}

////////////////////////////// Loop 開始(スキャンプログラム) //////////////////////////////
void loop(){			// 

	 int tmp;				// 
	 time_refresh();		// 時間の更新処理
	 link_refresh();		//	リンクリフレッシュ処理
	 special_refresh();	// 特殊リレーの更新処理
	 input_refresh();		// 入力更新処理
	 ldlg = 0x0; //  ブロック用変数;
	 aax = 0x0;  // 回路の状態保持変数;
	 trlg = 0x0; // ＭＰＳ／ＭＲＤ／ＭＰＰ;
	 iix = 0x01; // ＭＣ用変数の初期化;
	 ;
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_E(M9038,9038);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MOV(51) 
	 if (aax & iix) { 
	 	 D0000 = 0x7d0 ; 
	 } 
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0034,34);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// SUB(63) 
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0000, 0)) { 
	 	 D0000 = D0000 - 0x1 ; 
	 	 	 SET_UTRG_ON(UTRG0000,0);
	 	 } 
	 } else {
	 	 	 SET_UTRG_OFF(UTRG0000,0);
	 } 
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0035,35);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// ADD(62) 
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0001, 1)) { 
	 	 D0000 = D0000 + 0x1 ; 
	 	 	 SET_UTRG_ON(UTRG0001,1);
	 	 } 
	 } else {
	 	 	 SET_UTRG_OFF(UTRG0001,1);
	 } 
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_E(M9036,9036);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS(0C) 
	 trlg = (trlg << 1) | (aax); 
// MOV(51) 
	 if (aax & iix) { 
	 	 D8402 = D0000 ; 
	 } 
// MPP(0E) 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// MOV(51) 
	 if (aax & iix) { 
	 	 D8412 = D0000 ; 
	 } 
// LD(01) 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0023,23);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS(0C) 
	 trlg = (trlg << 1) | (aax); 
// PULSE(41) 
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0002, 2)) { 
	 	 	 if( ! pwm_setupf){
	 	 	 	 ledcSetup(0, 0x64, D8404);	// 
	 	 	 	 pwm_setupf |= 1 << 0;
	 	 	}
	 	 	 ledcAttachPin(25, 0);	// 
	 	 	 {
	 	 	 	 long dattemp=(long)D8402;
	 	 	 	 
	 	 	 	 dattemp = map(dattemp,D8405,D8406,D8407,D8408);
	 	 	 	 ledcWrite(0,dattemp);
	 	 	 }
	 	 	 SET_UTRG_ON(UTRG0002,2);
	 	 } else {
	 	 	 {
	 	 	 	 long dattemp=D8402;
	 	 	 	 
	 	 	 	 dattemp = map(dattemp,D8405,D8406,D8407,D8408);
	 	 	 	 ledcWrite(0,dattemp);
	 	 	 }
	 	 }
	 } else {
	 	 if ( GET_UTRG(UTRG0002,2) ){
	 	 	 ledcDetachPin(25);
	 	 	 pwm_setupf &= ~(1 << 0);
	 	 }
	 	 SET_UTRG_OFF(UTRG0002,2);
	 }
	 
// MPP(0E) 
	 aax = 0; 
	 aax |= (trlg & 0x1); 
	 trlg >>= 0x1; 
// PULSE(41) 
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0003, 3)) { 
	 	 	 if( ! pwm_setupf){
	 	 	 	 ledcSetup(1, 0x64, D8414);	// 
	 	 	 	 pwm_setupf |= 1 << 1;
	 	 	}
	 	 	 ledcAttachPin(26, 1);	// 
	 	 	 {
	 	 	 	 long dattemp=(long)D8412;
	 	 	 	 
	 	 	 	 dattemp = map(dattemp,D8415,D8416,D8417,D8418);
	 	 	 	 ledcWrite(1,dattemp);
	 	 	 }
	 	 	 SET_UTRG_ON(UTRG0003,3);
	 	 } else {
	 	 	 {
	 	 	 	 long dattemp=D8412;
	 	 	 	 
	 	 	 	 dattemp = map(dattemp,D8415,D8416,D8417,D8418);
	 	 	 	 ledcWrite(1,dattemp);
	 	 	 }
	 	 }
	 } else {
	 	 if ( GET_UTRG(UTRG0003,3) ){
	 	 	 ledcDetachPin(26);
	 	 	 pwm_setupf &= ~(1 << 1);
	 	 }
	 	 SET_UTRG_OFF(UTRG0003,3);
	 }
	 
// END(10) 
	// Serial.println();
	 SET_E_OFF(M9038,0);

}
////////////////////////////// Loop 終了 //////////////////////////////
