//   Professional File

////////////////////////////////////////////////////
// RenriVer 8.74  DllLibrary Arduino  0.05         //
// c source builder by  SEQ_CBuilder V            //
// TargetCPU = ESP32(WROOM32)                     //
// make    VBTestx.ino File  2020/01/31 20:12     //
////////////////////////////////////////////////////
// device_list //
 // X0000 	X0037 	X0038 	X0039 	// XDevice = 4
 // Y0002 	// YDevice = 1 
 // M0000 	M0001 	M0002 	M0003 	// MDevice = 4  
 // D0000 	D0001 	// DDevice = 2  
 // // TDevice = 0  
 // // CDevice = 0  
 // // LDevice = 0  
 // // rDevice = 0  
 // // jDevice = 0 
//// device_list //

#include  <M5Stack.h>
#include "VBTestx.h";
 // ;IEND_ST
// // タイマー割込み時の処理を行うタスク（１ｍｓ単位で呼び出される）
void InterruptFunction(void *args) { 
	 delay(1); 

	 while(1) {
	 	 if(xSemaphoreTake(timerSemaphore,0) == pdTRUE){
	 	 	 portENTER_CRITICAL(&timerMux);
	 	 	 
	 	 	 if (offCounter<=0){
	 	 	 	 onCounter = 2;
	 	 	 	 offCounter = 2;
	 	 	 	 SET_E_ON(M9053, 9053);
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_E(M9053,9053);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D0001 = D0000 ; 
	 } 
// OUT 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_Y_ON(Y0002,2);
	 } else { 
	 	 SET_Y_OFF(Y0002,2);
	 	 // 条件が不成立時マイスキャン実行されます。
	 }
	 
// IRET Hit 
	 	 	 	 }
	 	 	 if (onCounter<=0){
	 	 	 	 onCounter = 2;
	 	 	 	 offCounter = 2;
	 	 	 	 SET_E_OFF(M9053, 9053);
// IRET
// LDI 
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_E(M9053,9053);
	 if ( ! flag ){ //
	 	 aax |= 0x01; //
	 }//
//
// MPS 
	 trlg = (trlg << 1) | (aax); 
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 D0001 = D0000 ; 
	 } 
// OUTF 
// まだ未対応です。
	 if (aax & iix) { 
	 	 SET_Y_OFF(Y0002,2);
	 }
	 
// IRET Hit 
// IRET
// END 
	 	 	 }
	 	 	 portEXIT_CRITICAL(&timerMux);
	 	 }
	 	 vTaskDelay(1); // タスクの切り替えのために呼び出し(1ms待ち)
	 }
}

HardwareSerial mySerial1(1);  // 連枝のデバッグ用シリアルポート


// マイコンが起動するときに１度だけ呼び出される関数です。
// 主に初期化処理やデバイスの初期化のプログラムをユーザー側で作成します。
void setup(){
	 byte		tmp;

	 // M5Stackを使用する前の初期化関数の呼び出し
	 M5.begin();
	 dacWrite(25,0); // Speakerの出力を消す
	 
	 // プログラム書込みのシリアルポートを使用する場合は、以下の行のコメントを削除してください。
	 // Serial.begin(115200);
	 // Serial.println("setup start");


   mySerial1.begin(19200,SERIAL_8N1,17,16);  // パソコン側のシリアル
	 for (byte i=0; i<sizeof(in_no); i++) {
	 	 pinMode(in_no[i],INPUT);
	 }
	 
	 input_refresh();		// 入力更新処理
	 
	 for (byte i=0; i<sizeof(out_no); i++) {
	 	 pinMode(out_no[i],OUTPUT);
	 } 
	 
	 lasttime = micros(); // 時間の取得（ us単位 ）
	 lasttime_ms = millis(); // 時間の取得（ ms単位 )
	 q = 0x01;
	 SET_E_ON(M9038,0);     //  1スキャンＯＮリレーの生成
	 SET_E_ON(M9036,0);     //  常時ＯＮリレーの生成
	 SET_E_OFF(M9037,0);    // 常時ＯＦＦリレーの生成
	 
	  M5.Lcd.init();	// TFTの初期化関数の呼び出し
	  M5.Lcd.setRotation(3);	// TFTの表示モードのセット
	  M5.Lcd.fillScreen(TFT_BLACK);	// 背景の色を書き出し
	  M5.Lcd.setTextDatum(CL_DATUM);	// 文字書き出し基準位置を真中左ぞろえとする。
	// M5.Lcd.drawString("test",50,50);	// 文字の描画　(文字列,X位置,Y位置)
	// M5.Lcd.fillCircle(40,50,5,TFT_GREEN);	// 円の塗りつぶし (X位置,Y位置,半径,塗りつぶし色）
	// M5.Lcd.drawCircle(40,50,5,TFT_RED); // 円の描画　（X位置,Y位置,半径,線色）
	// M5.Lcd.fillRect(100,120,20,30,TFT_BLUE);	// 四角の描画　（左X位置,上Y位置,幅,高さ,塗りつぶし色）
	 	 timerSemaphore = xSemaphoreCreateBinary();
	 	  xTaskCreatePinnedToCore(InterruptFunction, "InterruptFunction", 4096, NULL, 5, NULL,1);
	 // Serial.println("setup end");
}


// Ａｒｄｕｉｎｏがプログラムの実行時、繰り返し呼び出す関数です。
// loop関数の処理が終わるとＡｒｄｕｉｎｏの必要な処理を行います。
// その処理が終われば、再度Ａｒｄｕｉｎｏがloop関数を呼び出します。
////////////////////////////// Loop 開始(スキャンプログラム) //////////////////////////////
void loop(){			// 

  static uint16_t dataLength;
  static uint8_t stxFlag=0;   

	 int tmp;				// 
	 time_refresh();		// 時間の更新処理
	 link_refresh();		//	リンクリフレッシュ処理
	 special_refresh();	// 特殊リレーの更新処理
	 output_refresh();	// 出力更新処理
	 input_refresh();		// 入力更新処理
	
	//  TFT のボタンを使用する場合のプログラム
	/*

	// BtnCX37のスイッチが押されたら条件分岐する書き方の一覧です。
	 if( M5.BtnA.read() ){
	 	  // この関数を呼び出した瞬間にボタンが押されていたら１、押されていないければ０
	 	  ;
	 }

	 if( M5.BtnA.wasPressed() ){
	 	  // 押されるたびに一度だけ１を返す
	 	  ;
	 }

	 if( M5.BtnA.isPressed()){
	 	  // 最後にread関数を呼び出したときの値を返す
	 	  ;
	 }
	 if( M5.BtnA.pressedFor(100) ){    
	 	  // 指定した時間（ミリ秒）押し続けられていると１を返す
	 	  ;
	 }
	*/

	 ldlg = 0x0; //  ブロック用変数;
	 aax = 0x0;  // 回路の状態保持変数;
	 trlg = 0x0; // ＭＰＳ／ＭＲＤ／ＭＰＰ;
	 iix = 0x01; // ＭＣ用変数の初期化;
	 ;
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0039,39);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OUT 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_M_ON(M0000,0);
	 } else { 
	 	 SET_M_OFF(M0000,0);
	 	 // 条件が不成立時マイスキャン実行されます。
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0038,38);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// OUT 
	 if (aax & iix) { 
	 	 // 条件が成立時マイスキャン実行されます。
	 	 SET_M_ON(M0001,1);
	 } else { 
	 	 SET_M_OFF(M0001,1);
	 	 // 条件が不成立時マイスキャン実行されます。
	 }
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0038,38);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// PLF 
	 
	 if (!(aax & iix)) {
	 	 if (!GET_UTRG(UTRG0000,0)) {
	 	 	 if (!GET_E(M9038,9038)) {
	 	 	 	 SET_M_ON(M0003,3);
	 	 	 	 // 立下り１スキャン目の処理
	 	 	 	 // ここに立下り時に１度実行するプログラムを記述します。
	 	 	 } 
	 	 	 SET_UTRG_ON(UTRG0000,0);
	 	 } else { 
	 	 	 	 // 立下がり後２スキャン目以降の処理
	 	 	 SET_M_OFF(M0003,3);
	 	 } 
	 } else { 
	 	 	 	 // 条件ＯＦＦの処理
	 	 SET_M_OFF(M0003,3);
	 	 SET_UTRG_OFF(UTRG0000,0);
	 }  
	 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_M(M0003,3);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 // 0x11,0x0
	 	 (V0011) = 0; 
	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0039,39);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0001, 1)) { 
	 	 // 0x0,0x1
	 	 (V0000) = 1; 
	 	 	 SET_UTRG_ON(UTRG0001,1);
	 	 } 
	 } else {
	 	 	 SET_UTRG_OFF(UTRG0001,1);
	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_X(X0037,37);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// MOV 
// D転送可能です。ビットデバイスはMのみ桁転送可能です。
	 if (aax & iix) { 
	 	 if (!GET_UTRG(UTRG0002, 2)) { 
	 	 // 0x0,0x2
	 	 (V0000) = 2; 
	 	 	 SET_UTRG_ON(UTRG0002,2);
	 	 } 
	 } else {
	 	 	 SET_UTRG_OFF(UTRG0002,2);
	 } 
// LD
	 ldlg = (ldlg << 1) | (aax << 1); //
	 aax = 0x0; //
	 flag = GET_M(M0002,2);
	 if (flag){ //
	 	 aax |= 0x01; //
	 }//
//
// T0ISTA 
// まだ未対応です。
    if (aax & iix) { 
        if (htimer==NULL){
			timerStart();
        }
//			InterruptFunction();
    } else {
			timerStop();
    }
	 output_refresh();	// 出力更新処理
//	 M5.update(); 
	// Serial.println();
	 SET_E_OFF(M9038,0);

 if (mySerial1.available()) {
    while(mySerial1.available()){
      int inByte = mySerial1.read();
			if ((stxFlag & 0x01) == 0) {  //  stx受信フラグがあるかどうかのチェック 0なし、1あり		
				if (inByte == 0x02) { //  １回目のＳＴＸ受信時		
					stxFlag = 1;    // STX受信フラグのセット		
					rvData[inposrc++] = (uint8_t)inByte;  // 受信データを格納		
				}		
				else {		
					inposrc = 0;		
					stxFlag = 0;		
				}		
			}		
			else {  // データサイズ受信フラグ判定		
				if ((stxFlag & 0x02) == 0) {  //  // データ長受信フラグがあるか判定 　0なし、2あり		
					rvData[inposrc++] = (uint8_t)inByte;    // 受信データを受信バッファにセット		
					dataLength = (uint8_t)inByte & 0x7F;  // データサイズをセット		
					stxFlag |= 0x02;    // データ長受信フラグありに変更		
				}		
				else {  // データサイズ受信フラグあり		
					rvData[inposrc++] = (uint8_t)inByte;    // 受信データを受信バッファにセット		
					if (dataLength < (inposrc - 4)) { // 受信データの位置が受信予定サイズより大きくなったら		
						inposrc = 0;            // 位置をクリアする		
						stxFlag = 0;            // 受信フラグをクリア		
					}		
					else if ((inposrc - 4) < dataLength) { // dataLengthより短い場合、データがそろっていない		
					}		
					else if (rvData[inposrc - 1] == 0x03) { // 終端文字ＥＴＸを受信したとき		
						int ressize;		
						ressize = AnalyzePacket(rvData, inposrc);		// 連枝からのモニタ要求に対する応答のデータ生成とデータ作成
						if (ressize>0) {		
							for (int sendcount = 0; sendcount < ressize; sendcount++) {		
								mySerial1.write(txData[sendcount]);		
							}		
						}		
						inposrc = 0;  // 位置をクリアする		
						stxFlag = 0;  //受信フラグをクリア		
					}		
					else {		
						// 受信予定サイズだけど、ETXじゃない場合   		
					}		
				}		
			}		
		}		
	}		


	  vTaskDelay(1);  // タスクの切り替えのために呼び出し(1ms待ち) 
	
}
////////////////////////////// Loop 終了 //////////////////////////////
